*************************************************************************
*                                                                       *
* Please Note:                                                          *
*                                                                       *
* (1) This computer program is written by Pierre Joly                   *
*  in conjunction with  an article in Statistical Modelling             *
*  "Estimating life expectancy of demented and institutionalized        * 
* subjects from interval-censored observations of a  Multi-state model" *
*                                                                       *
* (2) This program is free software; you can redistribute it and/or     *
*   modify  it under the terms of the GNU General Public License        *
*  as published by  the Free Software Foundation; either version 2      *
*  of the License, or (at your option) any later version.               *
*                                                                       *
*  This program is distributed in the hope that it will be useful,      *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of       *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
*  GNU General Public License for more details.                         *  
*   No warranties, express or implied, are made for this program.       *
*                                                                       *
*************************************************************************
c            Modele a cinq etats Markov non-homogene
c                avec censure par intervalles et troncature.
c                   version bis
c                                            25/02/03
c           corrige le    (last update)      20/02/09
      program spline
         double precision v0(5000),vl(5000),vj(5000),tv(5000),ti(5000)
         double precision aux(25000),hes(71,71)
         double precision b2(4),inf,sup,estimv,der(5000)
         double precision min,max,maxt,res,test,funcpa,b(70)
         double precision ve01(4000,6),ve02(4000,6),ve04(4000,6)
         double precision ve14(4000,6),ve24(4000,6)
         double precision ve13(4000,6),ve23(4000,6),ve34(4000,6)
         double precision v(5000),k0(3),bi,bs,u(3),fu(3),uh
         double precision the1(-2:20),the2(-2:20),the3(-2:20)
         double precision omeg1(25,25),omeg2(25,25),omeg3(25,25)
         integer ier,istop,irep2
         integer filtre01(6),filtre02(6),filtre04(6)
         integer filtre14(6),filtre24(6)
         integer filtre13(6),filtre23(6),filtre34(6)
         integer nz1,nz2,nz3,np,ni,n,cpt1,cpt2,cpt3,ver,nvat2,nvat3
         integer j,k,jj,ii,iii,iiii,iiiii,ij,i,i01,i02,i04
         integer i1,i2,i3,i4,i5,i6,i7,i8
         integer da(5000),dv(5000),di(5000)
         integer ndate,nvat1,irep,nn,er(5000)
         integer inv01,inv02,inv04,inv14,inv24,inv13,inv23,inv34
         integer nv01,nv02,nv04,nv14,nv24,nv13,nv23,nv34
         real tt0,tt1,tt2,tt3,tt4,vax(10)
         character*14 nomfich,nomfich01,nomfich02,nomfich04
         character*14 nomfich14,nomfich24,nomfich34,nomfich13
         character*14 nomfich23,nomfichpa,rien
         character*10 nomvarl,nomvar01(10),nomvar02(10),nomvar04(10)
         character*10 nomvar14(10),nomvar24(10)
         character*10 nomvar13(10),nomvar23(10),nomvar34(10)
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision date(11000)
         integer nv0(5000),nvl(5000),nvj(5000),ntv(5000),nti(5000)
         integer no,rec
         common /dace0/date
         common /dace1/zi1,zi2,zi3
         common /dace2/no,da,dv,di
         common /dace3/ndate,nz1,nz2,nz3
         common /dace4/nv0,nvl,nvj,ntv,nti
         common /ve1/ve01,ve02,ve04,ve14,ve24,ve13,ve23,ve34
         common /ve2/nv01,nv02,nv04,nv14,nv24,nv13,nv23,nv34
 
c------------  entre parametres -----

         open(2,file='mark5_09.inf',status='old')

c------------  entre non fichier et nombre sujet -----

         read(2,*)rien
         read(2,*)nomfich
         read(2,*)rien
         read(2,*)no
         read(2,*)rien
         read(2,*)ver
         inv01 = 0
         inv02 = 0
         inv04 = 0
         inv14 = 0
         inv24 = 0
         inv13 = 0
         inv23 = 0
         inv34 = 0
         if (ver.gt.0) then
            read(2,*)rien
         endif   
         do 3 i=1,ver
            read(2,*)nomvarl,filtre01(i),filtre02(i),filtre04(i),
     &                       filtre14(i),filtre24(i),
     &                       filtre13(i),filtre23(i),filtre34(i)
            inv01 = inv01 + filtre01(i)
            inv02 = inv02 + filtre02(i)
            inv04 = inv04 + filtre04(i)
            inv14 = inv14 + filtre14(i)
            inv24 = inv24 + filtre24(i)
            inv13 = inv13 + filtre13(i)
            inv23 = inv23 + filtre23(i)
            inv34 = inv34 + filtre34(i)
            if(filtre01(i).eq.1)then
               nomvar01(inv01) = nomvarl
            endif 
            if(filtre02(i).eq.1)then
               nomvar02(inv02) = nomvarl
            endif
            if(filtre04(i).eq.1)then
               nomvar04(inv04) = nomvarl
            endif
            if(filtre14(i).eq.1)then
               nomvar14(inv14) = nomvarl
            endif 
            if(filtre24(i).eq.1)then
               nomvar24(inv24) = nomvarl
            endif
            if(filtre13(i).eq.1)then
               nomvar13(inv13) = nomvarl
            endif
            if(filtre23(i).eq.1)then
               nomvar23(inv23) = nomvarl
            endif 
            if(filtre34(i).eq.1)then
               nomvar34(inv34) = nomvarl
            endif
 3       continue
         write(*,*)'nombre de variable explicative : ',inv01,inv02,inv04
     &   ,inv14,inv24,inv13,inv23,inv34

c------------  lecture fichier -----------------------

         open(9,file=nomfich,status='old')

         maxt = 0.d0
         cpt1 = 0
         cpt2 = 0
         cpt3 = 0
         k = 0
         do 10 i = 1,no
         read(9,*)i01,i02,i04,tt0,tt1,tt2,tt3,tt4,(vax(j),j=1,ver)
            do 5 ij=1,ver
               if((vax(ij).le.-32760).and.(filtre01(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre02(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre04(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre14(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre24(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre13(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre23(ij).eq.1))then
                  go to 9
               endif
               if((vax(ij).le.-32760).and.(filtre34(ij).eq.1))then
                  go to 9
               endif
 5          continue 
ccc            if((vax(1).eq.1))then
            k = k +1
c -----------------  c=1 censure a droite 01
            da(k) = i01
            cpt1  = cpt1 + i01
            dv(k) = i04
            cpt3  = cpt3 + i04
            di(k) = i02
            cpt2  = cpt2 + i02
            v0(k) = dble(tt0)
            vl(k) = dble(tt1)
            vj(k) = dble(tt2)
            tv(k) = dble(tt3)
            ti(k) = dble(tt4)
            i1 = 0
            i2 = 0
            i3 = 0
            i4 = 0
            i5 = 0
            i6 = 0
            i7 = 0
            i8 = 0
            do 6 ii = 1,ver
               if(filtre01(ii).eq.1)then
                  i1 = i1 + 1
                  ve01(i,i1) = dble(vax(ii))
               endif
               if(filtre02(ii).eq.1)then
                  i2 = i2 + 1
                  ve02(i,i2) = dble(vax(ii))
               endif
               if(filtre04(ii).eq.1)then
                  i3 = i3 + 1
                  ve04(i,i3) = dble(vax(ii))
               endif
               if(filtre14(ii).eq.1)then
                  i4 = i4 + 1
                  ve14(i,i4) = dble(vax(ii))
               endif
               if(filtre24(ii).eq.1)then
                  i5 = i5 + 1
                  ve24(i,i5) = dble(vax(ii))
               endif
               if(filtre13(ii).eq.1)then
                  i6 = i6 + 1
                  ve13(i,i6) = dble(vax(ii))
               endif
               if(filtre23(ii).eq.1)then
                  i7 = i7 + 1
                  ve23(i,i7) = dble(vax(ii))
               endif
               if(filtre34(ii).eq.1)then
                  i8 = i8 + 1
                  ve34(i,i8) = dble(vax(ii))
               endif
 6          continue   
             if (maxt.lt.tv(k))then
               maxt = tv(k)
            endif
cc            endif
 9          continue
 10      continue
         close(9)
         no = k
         write(*,*)'nombre de sujets',no,'  nombre de malades ',cpt1,
     &     ' nombre d institutionnalise', cpt2,' nombre de deces', cpt3 

         read(2,*)rien
         read(2,*)nz1,nz2,nz3
         if(nz1.gt.20)then
            nz1 = 20
         endif
         if(nz1.lt.5)then
            nz1 = 5
         endif
         if(nz2.gt.20)then
            nz2 = 20
         endif
         if(nz2.lt.5)then
            nz2 = 5
         endif
         if(nz3.gt.20)then
            nz3 = 20
         endif
         if(nz3.lt.5)then
            nz3 = 5
         endif
         write(*,*)'nombre de noeuds :',nz1,nz2,nz3,(nz1+nz2+nz3)



c--------------- zi ----------------------------------

c      construire vecteur zi (des noeuds)

         min = 0.d0
         max = maxt

         do 15 i = 1,5*no
            do 16 k = 1,no
               if(v0(k).ge.min)then 
                  if(v0(k).lt.max)then
                     max = v0(k)
                  endif   
               endif
               if((vl(k).ge.min))then
                  if(vl(k).lt.max)then
                     max = vl(k)
                  endif
               endif
               if(vj(k).ge.min)then 
                  if(vj(k).lt.max)then
                     max = vj(k)
                  endif   
               endif
               if((tv(k).ge.min))then
                  if(tv(k).lt.max)then
                     max = tv(k)
                  endif
               endif
               if(ti(k).ge.min)then 
                  if(ti(k).lt.max)then
                     max = ti(k)
                  endif   
               endif
 16         continue   
            aux(i) = max
            min = max + 1.d-12
            max = maxt
 15      continue

         date(1) = aux(1)
         k = 1
         do 17 i=2,5*no
            if(aux(i).gt.aux(i-1))then
               k = k+1
               date(k) = aux(i)
            endif 
 17      continue   
         ndate = k
         write(*,*)'ndate',ndate

         zi1(-2) = date(1)
         zi1(-1) = date(1)
         zi1(0) = date(1)
         zi1(1) = date(1)
         do 18 i=2,nz1-1
            zi1(i) =zi1(i-1)+(date(ndate)-date(1))/dble(nz1-1)
 18      continue    
         zi1(nz1) = date(ndate)
         zi1(nz1+1)=zi1(nz1)
         zi1(nz1+2)=zi1(nz1)
         zi1(nz1+3)=zi1(nz1)
c         write(*,*)zi1


   
         zi2(-2) = date(1)
         zi2(-1)= date(1)
         zi2(0)= date(1)
         zi2(1)= date(1)
         do 28 i=2,nz2-1
            zi2(i) =zi2(i-1)+(date(ndate)-date(1))/dble(nz2-1)
 28      continue    
         zi2(nz2) = date(ndate)
         zi2(nz2+1)=zi2(nz2)
         zi2(nz2+2)=zi2(nz2)
         zi2(nz2+3)=zi2(nz2)

   
         zi3(-2) = date(1)
         zi3(-1)= date(1)
         zi3(0)= date(1)
         zi3(1)= date(1)
         do 38 i=2,nz3-1
            zi3(i) =zi3(i-1)+(date(ndate)-date(1))/dble(nz3-1)
 38      continue    
         zi3(nz3) = date(ndate)
         zi3(nz3+1)=zi3(nz3)
         zi3(nz3+2)=zi3(nz3)
         zi3(nz3+3)=zi3(nz3)


 
c---------- affectation nt0,nt1,nt2 ----------------------------

            do 50 i=1,no
               if(v0(i).eq.0.d0)then
                  nv0(i) = 0
               endif 
               do 45 j=1,ndate
                  if(date(j).eq.v0(i))then
                     nv0(i)=j
                  endif
                  if(date(j).eq.vl(i))then
                     nvl(i)=j
                  endif
                 if(date(j).eq.vj(i))then
                     nvj(i)=j
                  endif
                  if(date(j).eq.ti(i))then
                     nti(i)=j
                  endif
                 if(date(j).eq.tv(i))then
                     ntv(i)=j
                  endif
 45            continue
 50          continue   

c---------- afectation des vecteurs de splines -----------------

         n  = nz1+2+nz2+2+nz3+2

         call vectot(nz1,nz2,nz3,ndate,ndate,ndate
     & ,omeg1,omeg2,omeg3)

         np = n

         do 74 i=1,np
            b(i)=5.d-1
 74      continue
         
         do 75 i=np+1,np+5
            b(i)=0.d0
 75      continue

         np = np+5

c----------- Estimation d'un effectif a risque ----------------
c-----------    pour les transitions 01, 02  et 04  ----------------

         der(1) = date(1)
         er(1) = 0
         do 76 i=2,100
            der(i) =der(i-1)+(date(ndate)-date(1))*0.01d0
            er(i) = 0
 76      continue    
         
         do 78 i=1,no
             if(da(i).eq.0)then
                if(di(i).eq.0)then
                   inf = v0(i)
                   sup = tv(i)
                else
                   inf = v0(i)
                   sup = ti(i) 
                endif   
             else
                if(di(i).eq.0)then
                   inf = v0(i)
                   sup = vl(i)
                else
                   if(ti(i).le.vj(i))then
                      inf = v0(i)
                      sup = ti(i)
                   else
                      inf = v0(i)
                      sup = vj(i)
                   endif   
                endif  
             endif
                do 77 j = 1,100
                if((inf.le.der(j)).and.(sup.ge.der(j)))then
                   er(j)=er(j)+1
                endif
 77          continue   
 78       continue

          open(13,file='efari')
          do 79 i=1,100
            write(13,*)real(der(i)),er(i)
 79       continue  
          close(13)


c---------- newton --------------------------------------------
         read(2,*)rien
         read(2,*)rec
         read(2,*)rien
         read(2,*)k0(1),k0(2),k0(3)

         nv01 = 0
         nv02 = 0
         nv04 = 0
         nv14 = 0
         nv24 = 0
         nv13 = 0
         nv23 = 0
         nv34 = 0

         nn = 3


         if(rec.eq.1)then
         b2(1) = dlog(k0(1))
         b2(2) = dlog(k0(2))
         b2(3) = dlog(k0(3))

         do 352 iii=1,2
         do 351 ii=1,3

            write(*,*)' '
            write(*,*)'~~~~~~~~~~~~~~~~~~~~~~~~~~~'
            write(*,*)'Recherche parametre ',ii,' num ',iii
            write(*,*)'~~~~~~~~~~~~~~~~~~~~~~~~~~~'
            write(*,*)' '

            uh = 1.d0

            if(b2(ii).gt.2.d0)then
               u(2) = b2(ii)
               u(1) = u(2) - uh
               u(3) = u(2) + uh
            else
               u(2) = 3.d0
               u(1) = u(2) - uh
               u(3) = u(2) + uh
            endif   


         b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)


         b2(ii) = u(2)
         fu(2) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         b2(ii) = u(3)
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         do 321 j=1,5
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1',u(3)
            u(1) = u(2)
            fu(1) = fu(2)
            u(2) = u(3)
            fu(2) = fu(3)
            u(3) = u(2) + uh
            b2(ii) = u(3)
            if(u(3).gt.17.d0)then
               write(*,*)'INFINI'
            else   
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
            endif
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2',u(1),u(3)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3',u(1)
                  u(3) = u(2)
                  fu(3) = fu(2)
                  u(2) = u(1)
                  fu(2) = fu(1)
                  u(1) = u(3) - 2.d0*uh
                 b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
               else
                  write(*,*)'PB'
               endif
            endif
         endif  
 321     continue
         
         write(*,*)' '
         write(*,*)'Direction'
         write(*,*)' '
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1, apres ',u(3)
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2, ZOOM entre',u(1),' et ',u(3)
               write(*,*)' '
c------------------------------------
         uh = 0.5d0
         u(3) = u(2)
         fu(3) = fu(2)
         u(2) = u(1) + uh
         b2(ii) = u(2)
         fu(2) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         do 322 j=1,2
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1bis',u(3)
            u(1) = u(2)
            fu(1) = fu(2)
            u(2) = u(3)
            fu(2) = fu(3)
            u(3) = u(2) + uh
            b2(ii) = u(3)
           if(u(3).gt.17.d0)then
               write(*,*)'INFINI'
            else  
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
            endif
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2 bis',u(1),u(3)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3 bis, ????????',u(1)
                  u(3) = u(2)
                  fu(3) = fu(2)
                  u(2) = u(1)
                  fu(2) = fu(1)
                  u(1) = u(3) - 2.d0*uh
                 b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
               else
                  write(*,*)'PB'
               endif
            endif
         endif  
 322     continue
c------------------------------------
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3, avant ',u(1)
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif 

         write(*,*)' '
         write(*,*)'ZOOM ZOOM'
         write(*,*)' '
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1, apres ',u(3)
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2, ZOOM ZOOM entre',u(1),' et ',u(3)
               write(*,*)' '
c------------------------------------
         uh = 0.25d0
         u(3) = u(2)
         fu(3) = fu(2)
         u(2) = u(1) + uh
         b2(ii) = u(2)
         fu(2) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         do 323 j=1,2
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1Ter',u(3)
            u(1) = u(2)
            fu(1) = fu(2)
            u(2) = u(3)
            fu(2) = fu(3)
            u(3) = u(2) + uh
            b2(ii) = u(3)
           if(u(3).gt.17.d0)then
               write(*,*)'INFINI'
            else  
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
            endif 
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2 Ter',u(2)
c               write(*,*)u
c               write(*,*)fu
c               b2(ii) = u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3 Ter, ????????',u(1)
                  u(3) = u(2)
                  fu(3) = fu(2)
                  u(2) = u(1)
                  fu(2) = fu(1)
                  u(1) = u(3) - 2.d0*uh
                 b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
               else
                  write(*,*)'PB'
               endif
            endif
        endif  
 323  continue
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3, avant ',u(1)
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif 
ccc---------------------
         if((iii.eq.1).and.(ii.eq.1))then
            write(*,*)'-- 1 --  1  -- '
         write(*,*)
         write(*,*)'-------------------------------'
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'Term 1',u(3)
            write(*,*)u
            write(*,*)fu
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'Term 2',u(2)
               write(*,*)u
               write(*,*)fu
               b2(ii) = u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'Term 3',u(1)
                  write(*,*)u
                  write(*,*)fu
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif
         else   
         write(*,*)' '
         write(*,*)'ZOOM ZOOM ZOOM'
         write(*,*)' '
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1, apres ',u(3)
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2, ZOOM ZOOM ZOOM entre',u(1),' et ',u(3)
               write(*,*)' '
c------------------------------------
         uh = 0.125d0
         u(3) = u(2)
         fu(3) = fu(2)
         u(2) = u(1) + uh
         b2(ii) = u(2)
         fu(2) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         do 324 j=1,2
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1 Qua',u(3)
            u(1) = u(2)
            fu(1) = fu(2)
            u(2) = u(3)
            fu(2) = fu(3)
            u(3) = u(2) + uh
            b2(ii) = u(3)
           if(u(3).gt.17.d0)then
               write(*,*)'INFINI'
            else  
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
            endif
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2 Qua',u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3 Qua, ????????',u(1)
                  u(3) = u(2)
                  fu(3) = fu(2)
                  u(2) = u(1)
                  fu(2) = fu(1)
                  u(1) = u(3) - 2.d0*uh
                 b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
               else
                  write(*,*)'PB'
               endif
            endif
         endif  
 324  continue
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3, avant ',u(1)
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif 
cc---------------------
         if((iii.eq.1).and.(ii.eq.2))then
            write(*,*)' -- 1 -- 2 --'
         write(*,*)
         write(*,*)'-------------------------------'
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'Term 1',u(3)
            write(*,*)u
            write(*,*)fu
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'Term 2',u(2)
               write(*,*)u
               write(*,*)fu
               b2(ii) = u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'Term 3',u(1)
                  write(*,*)u
                  write(*,*)fu
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif
         else   
        write(*,*)' '
         write(*,*)'ZOOM FINAL'
         write(*,*)' '
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1, apres ',u(3)
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2, ZOOM FINAL entre',u(1),' et ',u(3)
               write(*,*)' '
c------------------------------------
         uh = 0.125d0*0.5d0
         u(3) = u(2)
         fu(3) = fu(2)
         u(2) = u(1) + uh
         b2(ii) = u(2)
         fu(2) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)

         do 325 j=1,2
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'cas 1 FINAL',u(3)
            u(1) = u(2)
            fu(1) = fu(2)
            u(2) = u(3)
            fu(2) = fu(3)
            u(3) = u(2) + uh
            b2(ii) = u(3)
         fu(3) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'cas 2 FINAL',u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3 FINAL, ????????',u(1)
                  u(3) = u(2)
                  fu(3) = fu(2)
                  u(2) = u(1)
                  fu(2) = fu(1)
                  u(1) = u(3) - 2.d0*uh
                 b2(ii) = u(1)
         fu(1) = estimv(b2,nn,0,0.d0,0,0.d0,b,omeg1,omeg2,omeg3)
               else
                  write(*,*)'PB'
               endif
            endif
         endif  
 325  continue



         write(*,*)
         write(*,*)'-------------------------------'
         if((fu(1).lt.fu(2)).and.((fu(2).lt.fu(3))))then
            write(*,*)'Term 1',u(3)
            write(*,*)u
            write(*,*)fu
            b2(ii) = u(3)
         else 
            if((fu(1).lt.fu(2)).and.((fu(2).gt.fu(3))))then
               write(*,*)'Term 2',u(2)
               write(*,*)u
               write(*,*)fu
               b2(ii) = u(2)
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'Term 3',u(1)
                  write(*,*)u
                  write(*,*)fu
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif
c------------------------------------
            else
               if((fu(1).gt.fu(2)).and.((fu(2).gt.fu(3))))then
                  write(*,*)'cas 3, avant ',u(1)
                  b2(ii) = u(1)
               else
                  write(*,*)'PB'
               endif
            endif
         endif 
cc-------------------         
         endif
ccc-------------------
         endif
 351  continue
 352     continue

         k0(1) = dexp(b2(1))

         k0(2) = dexp(b2(2))

         k0(3) = dexp(b2(3))

         write(*,*)' '
         write(*,*)'-----------------------'
         write(*,*)'Maximum : ',fu
         write(*,*)'k0',k0

         endif
c---------------------------------------

         test=funcpa(b,np,0,0.d0,0,0.d0,k0)
         write(*,*)' '
         write(*,*)'test',test
         call marq98(k0,b,np,ni,v,hes,res,ier,istop)

         write(*,*)' '
         write(*,*)'Parametre d1,d2,d3,d13,d23'
         do 176 i=np-4,np
            j=i*(i+1)/2
c            write(*,*)i,b(i)
            write(*,*)'beta : ',b(i),'  SE',dsqrt(v(j))
 176      continue

         read(2,*)rien
         read(2,*)irep
         if(irep.eq.1)then
            read(2,*)rien
            read(2,*)nomfich01
            read(2,*)nomfich02
            read(2,*)nomfich04
            read(2,*)nomfich14
            read(2,*)nomfich24
            read(2,*)nomfich34
            read(2,*)nomfich13
            read(2,*)nomfich23
            call distance(nz1,nz2,nz3,hes,b,nomfich01,nomfich02,
     &        nomfich04,nomfich14,nomfich24,nomfich34,nomfich13
     &        ,nomfich23)
         endif   


         if((inv01+inv02+inv04+inv14+inv24+inv13+inv23+inv34).gt.0)then
            write(*,*)' '
            write(*,*)'       Recherche des parametres de regression'
            nv01 = inv01
            nv02 = inv02
            nv04 = inv04
            nv14 = inv14
            nv24 = inv24
            nv13 = inv13
            nv23 = inv23
            nv34 = inv34
            n = np+nv01+nv02+nv04+nv14+nv24+nv13+nv23+nv34
            do 122 i=np+1,n
               b(i)=0.d0
 122        continue  
            call marq98(k0,b,n,ni,v,hes,res,ier,istop)
            write(*,*)'log-vrais',res,' nb iter ',ni
            open(8,file='regr5b.res')
            write(8,*)'log-vrais',res,'  nb param',nv01+nv02+nv04+
     &       nv14+nv24+nv13+nv23+nv34
            write(8,*)'nb de sujets',no,'  nb de transitions 01 ',cpt1,
     &      '  nb de transitions 2', cpt2,' nb de transitions 4', cpt3
            do 125 i=1,nv01
               ii = n-nv01-nv02-nv04-nv14-nv24-nv13-nv23-nv34+i
               jj=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 0 ----------- >  1 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar01(i)
               bi = b(ii) - 1.96d0*dsqrt(v(jj))
               bs = b(ii) + 1.96d0*dsqrt(v(jj))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(jj))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(jj)))
         write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 125        continue 
            do 130 i=1,nv02
               ii = n-nv02-nv04-nv14-nv24-nv13-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 0 ----------- >  2 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar02(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 130     continue 
            do 135 i=1,nv04
               ii = n-nv04-nv14-nv24-nv13-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 0 ----------- >  4 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar04(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 135     continue 
            do 140 i=1,nv14
               ii = n-nv14-nv24-nv13-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 1 ----------- >  4 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar14(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 140     continue 
            do 145 i=1,nv24
               ii = n-nv24-nv13-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 2 ----------- >  4 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar24(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 145     continue
             do 150 i=1,nv13
               ii = n-nv13-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 1 ----------- >  3 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar13(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 150     continue
             do 155 i=1,nv23
               ii = n-nv23-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 2 ----------- >  3 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar23(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 155     continue
             do 160 i=1,nv34
               ii = n-nv34+i
               j=(ii)*(ii+1)/2
               write(8,*)' '
               write(8,*)' 3 ----------- >  4 '
               write(8,*)' '
               write(8,*)'Variable : ',nomvar34(i)
               bi = b(ii) - 1.96d0*dsqrt(v(j))
               bs = b(ii) + 1.96d0*dsqrt(v(j))
               write(8,*)' '
               write(8,*)'beta : ',b(ii),'  SE',dsqrt(v(j))
               write(8,*)'Wald : ',(b(ii)/dsqrt(v(j)))
            write(8,*)'RR : ',dexp(b(ii)),'  IC',dexp(bi),dexp(bs)
 160     continue
            close(8)
            write(*,*)' '
            write(*,*)' fichier regr3.res : variables explicatives'
            write(*,*)' '
         endif

         write(*,*)' '

         write(*,*)' '
         write(*,*)'Parametre d1,d2,d3,d13,d23'
         do 177 i=np-4,np
            j=i*(i+1)/2
            write(*,*)'beta : ',b(i),'  SE',dsqrt(v(j)),' RR',dexp(b(i))
 177     continue




         end

c========================== VECTOT ==============================
      subroutine vectot(nz1,nz2,nz3,ndate1,ndate2,ndate3
     & ,omeg1,omeg2,omeg3)
         double precision omeg1(25,25),omeg2(25,25),omeg3(25,25)
         integer nz1,nz2,nz3,ndate1,ndate2,ndate3,n
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision date(11000)
         common /dace0/date
         common /dace1/zi1,zi2,zi3
         double precision mm3b(12000),mm2b(12000),mm1b(12000),mmb(12000)
         double precision im3b(12000),im2b(12000),im1b(12000),imb(12000)
         common /mem3/mm3b,mm2b,mm1b,mmb
         common /mem4/im3b,im2b,im1b,imb
         double precision mm3c(12000),mm2c(12000),mm1c(12000),mmc(12000)
         double precision im3c(12000),im2c(12000),im1c(12000),imc(12000)
         common /mem5/mm3c,mm2c,mm1c,mmc
         common /mem6/im3c,im2c,im1c,imc
         double precision m3m3a(50),m2m2a(50),m1m1a(50),mmma(50)
         double precision m3m1a(50),m3ma(50),m2m1a(50),m2ma(50)
         double precision m3m3b(50),m2m2b(50),m1m1b(50),mmmb(50)
         double precision m3m1b(50),m3mb(50),m2m1b(50),m2mb(50)
         double precision m3m2a(50),m1ma(50),m3m2b(50),m1mb(50)
         double precision m3m3c(50),m2m2c(50),m1m1c(50),mmmc(50)
         double precision m3m1c(50),m3mc(50),m2m1c(50),m2mc(50)
         double precision m3m2c(50),m1mc(50)
         common /pen1/m3m3a,m2m2a,m1m1a,mmma,m3m2a
         common /pen2/m3m1a,m3ma,m2m1a,m2ma,m1ma
         common /pen3/m3m3b,m2m2b,m1m1b,mmmb,m3m2b
         common /pen4/m3m1b,m3mb,m2m1b,m2mb,m1mb
         common /pen5/m3m3c,m2m2c,m1m1c,mmmc,m3m2c
         common /pen6/m3m1c,m3mc,m2m1c,m2mc,m1mc


         n = nz2+2
         call vecspli(n,ndate2,zi2,date,mm3b,mm2b,mm1b,mmb,im3b,im2b
     &      ,im1b,imb)
         n = nz3+2
         call vecspli(n,ndate3,zi3,date,mm3c,mm2c,mm1c,mmc,im3c,im2c
     &      ,im1c,imc)

         n = nz1+2
         call vecpen(n,zi1,m3m3a,m2m2a,m1m1a,mmma,m3m2a,m3m1a,m3ma
     &       ,m2m1a,m2ma,m1ma)
         n = nz2+2
         call vecpen(n,zi2,m3m3b,m2m2b,m1m1b,mmmb,m3m2b,m3m1b,m3mb
     &       ,m2m1b,m2mb,m1mb)
         n = nz3+2
         call vecpen(n,zi3,m3m3c,m2m2c,m1m1c,mmmc,m3m2c,m3m1c,m3mc
     &       ,m2m1c,m2mc,m1mc)


         call calcomeg(nz1+2,omeg1,m3m3a,m2m2a,m1m1a,mmma
     &                     ,m3m2a,m3m1a,m3ma,m2m1a,m2ma,m1ma)

         call calcomeg(nz2+2,omeg2,m3m3b,m2m2b,m1m1b,mmmb
     &                    ,m3m2b,m3m1b,m3mb,m2m1b,m2mb,m1mb)

         call calcomeg(nz3+2,omeg3,m3m3c,m2m2c,m1m1c,mmmc
     &                    ,m3m2c,m3m1c,m3mc,m2m1c,m2mc,m1mc)
 
         end
c========================== VECSPLI ==============================
      subroutine vecspli(n,ndate,zi,date,mm3,mm2,mm1,mm,im3,im2,im1,im)
         integer n,ndate
         double precision ht,htm,h2t,ht2,ht3,hht,h,hh,h2
         double precision h3,h4,h3m,h2n,hn,hh3,hh2
         integer i,j,k
         double precision zi(-2:20),date(10000)
         double precision mm3(12000),mm2(12000),mm1(12000),mm(12000)
         double precision im3(12000),im2(12000),im1(12000),im(12000)

c----------  calcul de u(ti) ---------------------------
c    attention the(1)  sont en nz=1
c        donc en ti on a the(i)

         do 8 i=1,ndate-1
            do 6 k = 2,n-2
               if ((date(i).ge.zi(k-1)).and.(date(i).lt.zi(k)))then
                  j = k-1
               endif
 6          continue 
            ht = date(i)-zi(j)
            htm= date(i)-zi(j-1)
            h2t= date(i)-zi(j+2)
            ht2 = zi(j+1)-date(i)
            ht3 = zi(j+3)-date(i)
            hht = date(i)-zi(j-2)
            h = zi(j+1)-zi(j)
            hh= zi(j+1)-zi(j-1)
            h2= zi(j+2)-zi(j)
            h3= zi(j+3)-zi(j)
            h4= zi(j+4)-zi(j)
            h3m= zi(j+3)-zi(j-1)
            h2n=zi(j+2)-zi(j-1)
            hn= zi(j+1)-zi(j-2)
            hh3 = zi(j+1)-zi(j-3)
            hh2 = zi(j+2)-zi(j-2)
            mm3(i) = ((4.d0*ht2*ht2*ht2)/(h*hh*hn*hh3))
            mm2(i) = ((4.d0*hht*ht2*ht2)/(hh2*hh*h*hn))+((-4.d0*h2t*htm
     &       *ht2)/(hh2*h2n*hh*h))+((4.d0*h2t*h2t*ht)/(hh2*h2*h*h2n))
            mm1(i) = (4.d0*(htm*htm*ht2)/(h3m*h2n*hh*h))+((-4.d0*htm*ht*
     &       h2t)/(h3m*h2*h*h2n))+((4.d0*ht3*ht*ht)/(h3m*h3*h2*h))
            mm(i)  = 4.d0*(ht*ht*ht)/(h4*h3*h2*h)
            im3(i) = (0.25d0*(date(i)-zi(j-3))*mm3(i))+(0.25d0*hh2
     &       *mm2(i))+(0.25d0*h3m*mm1(i))+(0.25d0*h4*mm(i))
            im2(i) = (0.25d0*hht*mm2(i))+(h3m*mm1(i)*0.25d0)
     &               +(h4*mm(i)*0.25d0)
            im1(i) = (htm*mm1(i)*0.25d0)+(h4*mm(i)*0.25d0)
            im(i)  = ht*mm(i)*0.25d0
 8       continue


         end
c========================== VECPEN ==============================
      subroutine vecpen(n,zi,m3m3,m2m2,m1m1,mmm,m3m2,m3m1,m3m,m2m1
     &     ,m2m,m1m)
         integer n
         double precision h,hh,h2,h3,h4,h3m,h2n,hn,hh3,hh2
         double precision a3,a2,b2,c2,a1,b1,c1,a0,x3,x2,x
         integer i
         double precision zi(-2:20)
         double precision m3m3(50),m2m2(50),m1m1(50),mmm(50),m3m2(50)
         double precision m3m1(50),m3m(50),m2m1(50),m2m(50),m1m(50)

         do 20 i=1,n-3
            h = zi(i+1)-zi(i)
            hh= zi(i+1)-zi(i-1)
            h2= zi(i+2)-zi(i)
            h3= zi(i+3)-zi(i)
            h4= zi(i+4)-zi(i)
            h3m= zi(i+3)-zi(i-1)
            h2n=zi(i+2)-zi(i-1)
            hn= zi(i+1)-zi(i-2)
            hh3 = zi(i+1)-zi(i-3)
            hh2 = zi(i+2)-zi(i-2)
            a3 = h*hh*hn*hh3
            a2 = hh2*hh*h*hn
            b2 = hh2*h2n*hh*h
            c2 = hh2*h2*h*h2n
            a1 = h3m*h2n*hh*h
            b1 = h3m*h2*h*h2n
            c1 = h3m*h3*h2*h
            a0 = h4*h3*h2*h
            x3 = zi(i+1)*zi(i+1)*zi(i+1)-zi(i)*zi(i)*zi(i)
            x2 = zi(i+1)*zi(i+1)-zi(i)*zi(i)
            x  = zi(i+1)-zi(i)
            m3m3(i) = (192.d0*h/(hh*hn*hh3*hh*hn*hh3))
            m2m2(i) = 64.d0*(((3.d0*x3-(3.d0*x2*(2.d0*zi(i+1)+zi(i-2)
     &      ))+x*(4.d0*zi(i+1)*zi(i+1)+zi(i-2)*zi(i-2)+4.d0*zi(i+1)
     &      *zi(i-2)))/(a2*a2)))
            m2m2(i) = m2m2(i) + 64.d0*(((3.d0*x3-(3.d0*x2*(zi(i+2)
     &      +zi(i-1)+zi(i+1)))+x*(zi(i+2)*zi(i+2)+zi(i-1)*zi(i-1)
     &      +zi(i+1)*zi(i+1)+2.d0*zi(i+2)*zi(i-1)+2.d0*zi(i+2)
     &      *zi(i+1)+2.d0*zi(i-1)*zi(i+1)))/(b2*b2)))
            m2m2(i) = m2m2(i) +64.d0*((3.d0*x3-(3.d0*x2*(2.d0*zi(i+2)
     &     +zi(i)))+x*(4.d0*zi(i+2)*zi(i+2)+zi(i)*zi(i)+4.d0*zi(i+2)
     &      *zi(i)))/(c2*c2))
            m2m2(i) = m2m2(i) +128.d0*((3.d0*x3-(1.5d0*x2*(zi(i+2)
     &      +zi(i-1)+3.d0*zi(i+1)+zi(i-2)))+x*(2.d0*zi(i+1)*zi(i+2)
     &      +2.d0*zi(i+1)*zi(i-1)+2.d0*zi(i+1)*zi(i+1)+zi(i-2)*zi(i+2)
     &      +zi(i-2)*zi(i-1)+zi(i-2)*zi(i+1)))/(a2*b2))
            m2m2(i) = m2m2(i) + 128.d0*((3.d0*x3-(1.5d0*
     &      x2*(2.d0*zi(i+2)+zi(i)+2.d0*zi(i+1)+zi(i-2)))+x*
     &      (4.d0*zi(i+1)*zi(i+2)+2.d0*zi(i+1)*zi(i)+2.d0*zi(i-2)
     &      *zi(i+2)+zi(i-2)*zi(i)))/(a2*c2))
            m2m2(i) = m2m2(i) + 128.d0*((3.d0*x3-(1.5d0*x2
     &     *(3.d0*zi(i+2)+zi(i)+zi(i-1)+zi(i+1)))+x*(zi(i+2)*zi(i)+
     &      2.d0*zi(i-1)*zi(i+2)+zi(i)*zi(i-1)+2.d0*zi(i+1)*zi(i+2)
     &      +zi(i+1)*zi(i)+2.d0*zi(i+2)*zi(i+2)))/(b2*c2))
            m1m1(i) = 64.d0*((3.d0*x3-(3.d0*x2*(2.d0*zi(i-1)+zi(i+1)))
     &      +x*(4.d0*zi(i-1)*zi(i-1)+zi(i+1)*zi(i+1)+4.d0*zi(i-1)
     &      *zi(i+1)))/(a1*a1))
            m1m1(i) = m1m1(i) + 64.d0*((3.d0*x3-(3.d0*x2*(zi(i-1)+zi(i)     
     &      +zi(i+2)))+x*(zi(i-1)*zi(i-1)+zi(i)*zi(i)+zi(i+2)*
     &      zi(i+2)+2.d0*zi(i-1)*zi(i)+2.d0*zi(i-1)*zi(i+2)+2.d0*
     &      zi(i)*zi(i+2)))/(b1*b1))
            m1m1(i) = m1m1(i) + 64.d0*((3.d0*x3-(3.d0*x2*(zi(i+3)
     &      +2.d0*zi(i)))+x*(zi(i+3)*zi(i+3)+4.d0*zi(i)*zi(i)
     &      +4.d0*zi(i+3)*zi(i)))/(c1*c1)) 
            m1m1(i) = m1m1(i) + 128.d0*((3.d0*x3-(1.5d0*x2*(3.d0
     &      *zi(i-1)+zi(i)+zi(i+2)+zi(i+1)))+x*(2.d0*zi(i-1)*zi(i-1)
     &      +2.d0*zi(i-1)*zi(i)+2.d0*zi(i-1)*zi(i+2)+zi(i+1)*zi(i-1)
     &      +zi(i+1)*zi(i)+zi(i+1)*zi(i+2)))/(a1*b1))
            m1m1(i) = m1m1(i) + 128.d0*((3.d0*x3-(1.5d0*x2*(zi(i+3)+
     &      2.d0*zi(i)+2.d0*zi(i-1)+zi(i+1)))+x*(2.d0*zi(i-1)*zi(i+3)
     &      +4.d0*zi(i-1)*zi(i)+zi(i+1)*zi(i+3)+2.d0*zi(i+1)*zi(i)))
     &       /(a1*c1))    
            m1m1(i) = m1m1(i) + 128.d0*((3.d0*x3-(1.5d0*x2*(zi(i+3)+3.d0
     &      *zi(i)+zi(i-1)+zi(i+2)))+x*(zi(i-1)*zi(i+3)+2.d0*zi(i-1)    
     &      *zi(i)+zi(i+3)*zi(i)+2.d0*zi(i)*zi(i)+zi(i+2)*zi(i+3)
     &      +2.d0*zi(i+2)*zi(i)))/(b1*c1))
            mmm(i) = (192.d0*h/(h4*h3*h2*h4*h3*h2))
            m3m2(i) = 192.d0*(((-x3+(0.5d0*x2*(5.d0*zi(i+1)+zi(i-2)
     &      ))-x*(2.d0*zi(i+1)*zi(i+1)+zi(i+1)*zi(i-2)))/(a3*a2))
     &      +((-x3+(0.5d0*x2*(4.d0*zi(i+1)+zi(i-1)+zi(i+2)))-x*
     &       (zi(i+1)*zi(i+2)+zi(i+1)*zi(i-1)+zi(i+1)*zi(i+1)))/(a3*b2))
     &      +((-x3+(0.5d0*x2*(3.d0*zi(i+1)+2.d0*zi(i+2)+zi(i)))-x*
     &      (2.d0*zi(i+1)*zi(i+2)+zi(i+1)*zi(i)))/(a3*c2)) )
            m3m1(i) = 192.d0*(((x3-(0.5d0*x2*(4.d0*zi(i+1)+2.d0*zi(i-1)
     &      ))+x*(2.d0*zi(i+1)*zi(i-1)+zi(i+1)*zi(i+1)))/(a3*a1))
     &      +((x3-(0.5d0*x2*(3.d0*zi(i+1)+zi(i+2)+zi(i-1)+zi(i)))
     &      +x*(zi(i+1)*zi(i-1)+zi(i+1)*zi(i)+zi(i+1)*zi(i+2)))/(b1*a3))
     &     +((x3-(0.5d0*x2*(3.d0*zi(i+1)+zi(i+3)+2.d0*zi(i)))+x*(zi(i+1)
     &      *zi(i+3)+2.d0*zi(i+1)*zi(i)))/(c1*a3)) )
            m3m(i) = 576.d0*((-(x3/3.d0)+(0.5d0*x2*(zi(i+1)+zi(i)))
     &       -x*zi(i+1)*zi(i))/(a3*a0))
            m2m1(i) = 64.d0*((-3.d0*x3+(1.5d0*x2*(2.d0*zi(i-1)+3.d0*
     &      zi(i+1)+zi(i-2)))-x*(4.d0*zi(i+1)*zi(i-1)+2.d0*zi(i+1)
     &      *zi(i+1)+2.d0*zi(i-2)*zi(i-1)+zi(i-2)*zi(i+1)))/(a2*a1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(zi(i-1)+
     &      zi(i)+zi(i+2)+2.d0*zi(i+1)+zi(i-2)))-x*(2.d0*zi(i+1)*zi(i-1)
     &      +2.d0*zi(i+1)*zi(i)+2.d0*zi(i+1)*zi(i+2)+zi(i-2)*zi(i-1)+
     &      zi(i-2)*zi(i)+zi(i-2)*zi(i+2)))/(a2*b1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(zi(i+3)+2.d0
     &      *zi(i)+2.d0*zi(i+1)+zi(i-2)))-x*(2.d0*zi(i+1)*zi(i+3)+4.d0
     &      *zi(i+1)*zi(i)+zi(i-2)*zi(i+3)+2.d0*zi(i-2)*zi(i)))/(a2*c1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*
     &      (3.d0*zi(i-1)+2.d0*zi(i+1)+zi(i+2)))-x*(2.d0*zi(i+2)*zi(i-1)
     &      +zi(i+2)*zi(i+1)+2.d0*zi(i-1)*zi(i-1)+3.d0
     &       *zi(i+1)*zi(i-1)+zi(i+1)*zi(i+1)))/(b2*a1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(2.d0
     &      *zi(i-1)+zi(i)+2.d0*zi(i+2)+zi(i+1)))-x*(zi(i+2)*zi(i-1)
     &      +zi(i+2)*zi(i)+zi(i+2)*zi(i+2)+zi(i-1)*zi(i-1)+zi(i-1)
     &      *zi(i)+zi(i-1)*zi(i+2)+zi(i+1)*zi(i-1)+zi(i+1)*zi(i)
     &      +zi(i+1)*zi(i+2)))/(b2*b1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(zi(i+3)
     &      +2.d0*zi(i)+zi(i+2)+zi(i-1)+zi(i+1)))-x*(zi(i+2)*zi(i+3)
     &      +2.d0*zi(i+2)*zi(i)+zi(i-1)*zi(i+3)+2.d0*zi(i-1)*zi(i)
     &      +zi(i+1)*zi(i+3)+2.d0*zi(i+1)*zi(i)))/(b2*c1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(2.d0*zi(i-1)
     &      +zi(i+1)+2.d0*zi(i+2)+zi(i)))-x*(4.d0*zi(i+2)*zi(i-1)+2.d0*
     &      zi(i+2)*zi(i+1)+2.d0*zi(i)*zi(i-1)+zi(i)*zi(i+1)))/(c2*a1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(zi(i-1)
     &      +2.d0*zi(i)+3.d0*zi(i+2)))-x*(2.d0*zi(i+2)*zi(i-1)+2.d0
     &      *zi(i+2)*zi(i)+2.d0*zi(i+2)*zi(i+2)+zi(i)*zi(i-1)+zi(i)
     &      *zi(i)+zi(i)*zi(i+2)))/(c2*b1))
            m2m1(i) = m2m1(i) + 64.d0*((-3.d0*x3+(1.5d0*x2*(zi(i+3)
     &      +3.d0*zi(i)+2.d0*zi(i+2)))-x*(2.d0*zi(i+2)*zi(i+3)+4.d0
     &       *zi(i+2)*zi(i)+zi(i)*zi(i+3)+2.d0*zi(i)*zi(i)))/(c2*c1))
            m2m(i) = 192.d0*(((x3-(0.5d0*x2*(3.d0*zi(i)+2.d0*zi(i+1)
     &      +zi(i-2)))+x*(2.d0*zi(i+1)*zi(i)+zi(i-2)*zi(i)))/(a2*a0))
     &      +((x3-(0.5d0*x2*(3.d0*zi(i)+zi(i+2)+zi(i-1)+zi(i+1)))
     &       +x*(zi(i+2)*zi(i)+zi(i-1)*zi(i)+zi(i+1)*zi(i)))/(b2*a0))
     &      +((x3-(0.5d0*x2*(4.d0*zi(i)+2.d0*zi(i+2)))+x*(2.d0*zi(i+2)
     &      *zi(i)+zi(i)*zi(i)))/(c2*a0)) )
            m1m(i) = 192.d0*(((-x3+(0.5d0*x2*(3.d0*zi(i)+2.d0*zi(i-1)
     &      +zi(i+1)))-x*(2.d0*zi(i-1)*zi(i)+zi(i+1)*zi(i)))/(a1*a0))
     &      +((-x3+(0.5d0*x2*(4.d0*zi(i)+zi(i-1)+zi(i+2)))
     &       -x*(zi(i-1)*zi(i)+zi(i)*zi(i)+zi(i+2)*zi(i)))/(b1*a0))
     &      +((-x3+(0.5d0*x2*(5.d0*zi(i)+zi(i+3)))-x*(zi(i+3)*zi(i)
     &      +2.d0*zi(i)*zi(i)))/(c1*a0)) )
 20       continue

          end


c========================          FUNCPA         ====================
      double precision function funcpa(b,np,id,thi,jd,thj,k0)
         double precision  b(70),thi,thj,bh(70),pe1,pe2,pe3
         double precision the1(-2:20),the2(-2:20),the3(-2:20)
         integer np,id,jd,i,j,k
         double precision pe,res,res1,k0(3),resa,resb,resc,resf
         double precision dut2(12000),dut3(12000),resd,rese
         double precision h1,v1,v2,v3,v13,v23,resf1,resf2
         double precision ve01(4000,6),ve02(4000,6),ve04(4000,6)
         double precision ve14(4000,6),ve24(4000,6)
         double precision ve13(4000,6),ve23(4000,6),ve34(4000,6)
         double precision p22,p11,p33,p00
         integer no,ndate,nz1,nz2,nz3,nx
         integer nv01,nv02,nv04,nv14, nv24,nv13,nv23,nv34
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         double precision m3m3a(50),m2m2a(50),m1m1a(50),mmma(50)
         double precision m3m1a(50),m3ma(50),m2m1a(50),m2ma(50)
         double precision m3m3b(50),m2m2b(50),m1m1b(50),mmmb(50)
         double precision m3m1b(50),m3mb(50),m2m1b(50),m2mb(50)
         double precision m3m2a(50),m1ma(50),m3m2b(50),m1mb(50)
         double precision m3m3c(50),m2m2c(50),m1m1c(50),mmmc(50)
         double precision m3m1c(50),m3mc(50),m2m1c(50),m2mc(50)
         double precision m3m2c(50),m1mc(50)
         common /pen1/m3m3a,m2m2a,m1m1a,mmma,m3m2a
         common /pen2/m3m1a,m3ma,m2m1a,m2ma,m1ma
         common /pen3/m3m3b,m2m2b,m1m1b,mmmb,m3m2b
         common /pen4/m3m1b,m3mb,m2m1b,m2mb,m1mb
         common /pen5/m3m3c,m2m2c,m1m1c,mmmc,m3m2c
         common /pen6/m3m1c,m3mc,m2m1c,m2mc,m1mc
         double precision mm3b(12000),mm2b(12000),mm1b(12000),mmb(12000)
         double precision im3b(12000),im2b(12000),im1b(12000),imb(12000)
         common /mem3/mm3b,mm2b,mm1b,mmb
         common /mem4/im3b,im2b,im1b,imb
         double precision mm3c(12000),mm2c(12000),mm1c(12000),mmc(12000)
         double precision im3c(12000),im2c(12000),im1c(12000),imc(12000)
         common /mem5/mm3c,mm2c,mm1c,mmc
         common /mem6/im3c,im2c,im1c,imc
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision date(11000)
         integer da(5000),dv(5000),di(5000)
         common /dace0/date
         common /dace1/zi1,zi2,zi3
         common /dace2/no,da,dv,di
         common /dace3/ndate,nz1,nz2,nz3
         integer nv0(5000),nvl(5000),nvj(5000),ntv(5000),nti(5000)
         common /dace4/nv0,nvl,nvj,ntv,nti
         common /ve1/ve01,ve02,ve04,ve14,ve24,ve13,ve23,ve34
         common /ve2/nv01,nv02,nv04,nv14,nv24,nv13,nv23,nv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /pene/pe

         do 2 i=1,np
            bh(i)=b(i)
 2       continue

         if (id.ne.0) bh(id)=bh(id)+thi
         if (jd.ne.0) bh(jd)=bh(jd)+thj    

         do 3 i=1,nz1+2
            the1(i-3)=(bh(i))*(bh(i))
 3       continue
         do 4 i=1,nz2+2
            j = nz1+2+i
            the2(i-3)=(bh(j))*(bh(j))
 4       continue
         do 5 i=1,nz3+2
            j = nz2+2+nz1+2+i
            the3(i-3)=(bh(j))*(bh(j))
 5       continue

         v1 = dexp(bh(nz1+2+nz2+2+nz3+2+1))
         v2 = dexp(bh(nz1+2+nz2+2+nz3+2+2))
         v3 = dexp(bh(nz1+2+nz2+2+nz3+2+3))
         v13= dexp(bh(nz1+2+nz2+2+nz3+2+4))
         v23= dexp(bh(nz1+2+nz2+2+nz3+2+5))

c----------  calcul de u(ti) ---------------------------
c    attention the(1)  sont en nz=1
c        donc en ti on a the(i)


         dut2(1) = (the2(-2)*4.d0/(zi2(2)-zi2(1)))
         do 9 i=2,ndate-1
            do 8 k = 2,nz2
               if ((date(i).ge.zi2(k-1)).and.(date(i).lt.zi2(k)))then
                  j = k-1
               endif
 8          continue 
            dut2(i) = (the2(j-3)*mm3b(i))+(the2(j-2)*mm2b(i))
     &       +(the2(j-1)*mm1b(i))+(the2(j)*mmb(i))
 9       continue
         i = nz2
         h1 = (zi2(i)-zi2(i-1))
         dut2(ndate) = (4.d0*the2(i-1)/h1)

         dut3(1) = (the3(-2)*4.d0/(zi3(2)-zi3(1)))
         do 11 i=2,ndate-1
            do 10 k = 2,nz3
               if ((date(i).ge.zi3(k-1)).and.(date(i).lt.zi3(k)))then
                  j = k-1
               endif
 10         continue 
            dut3(i) = (the3(j-3)*mm3c(i))+(the3(j-2)*mm2c(i))
     &       +(the3(j-1)*mm1c(i))+(the3(j)*mmc(i))
 11      continue
         i = nz3
         h1 = (zi3(i)-zi3(i-1))
         dut3(ndate) = (4.d0*the3(i-1)/h1)

c---------- calcul de la vraisemblance ------------------

          res = 0.d0
          do 20 i=1,no
             vv01 = 0.d0
             vv02 = 0.d0
             vv04 = 0.d0
             vv14 = 0.d0
             vv24 = 0.d0
             vv13 = 0.d0
             vv23 = 0.d0
             vv34 = 0.d0
             if(nv01.gt.0)then
                nx = np-nv01-nv02-nv04-nv14-nv24-nv13-nv23-nv34
                do 12 j=1,nv01
                vv01 =vv01 + bh(nx+j)*(ve01(i,j))
 12             continue
             endif 
             if(nv02.gt.0)then
                nx = np-nv02-nv04-nv14-nv24-nv13-nv23-nv34
                do 13 j=1,nv02
                vv02 =vv02 + bh(nx+j)*(ve02(i,j))
 13          continue
             endif 
             if(nv04.gt.0)then
                nx = np-nv04-nv14-nv24-nv13-nv23-nv34
                do 14 j=1,nv04
                vv04 =vv04 + bh(nx+j)*(ve04(i,j))
 14          continue
             endif 
             if(nv14.gt.0)then
                nx = np-nv14-nv24-nv13-nv23-nv34
                do 15 j=1,nv14
                vv14 =vv14 + bh(nx+j)*(ve14(i,j))
 15          continue
             endif
             if(nv24.gt.0)then
                nx = np-nv24-nv13-nv23-nv34
                do 16 j=1,nv24
                vv24 =vv24 + bh(nx+j)*(ve24(i,j))
 16          continue
             endif
             if(nv13.gt.0)then
                nx = np-nv13-nv23-nv34
                do 17 j=1,nv13
                vv13 =vv13 + bh(nx+j)*(ve13(i,j))
 17          continue
             endif
             if(nv23.gt.0)then
                nx = np-nv23-nv34
                do 18 j=1,nv23
                vv23 =vv23 + bh(nx+j)*(ve23(i,j))
 18          continue
             endif
             if(nv34.gt.0)then
                nx = np-nv34
                do 19 j=1,nv34
                vv34 =vv34 + bh(nx+j)*(ve34(i,j))
 19          continue
             endif
             vv01 = dexp(vv01)
             vv02 = dexp(vv02)
             vv04 = dexp(vv04)
             vv14 = dexp(vv14)
             vv24 = dexp(vv24)
             vv13 = dexp(vv13)
             vv23 = dexp(vv23)
             vv34 = dexp(vv34)

             res1 = 0.d0
             resa = 0.d0
             resb = 0.d0
             resc = 0.d0
             resd = 0.d0
             rese = 0.d0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

             if(da(i).eq.0)then
c              pas diagnostique dement
                if(di(i).eq.0)then
c                 pas institutionalise
                   resa = p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                   resb = p00(date(nvl(i)),date(ntv(i)),the1,the2,the3)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))*vv04
                   endif
                   call p01(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            resc,v1,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v1*vv14
                   endif
                   call p02(date(nti(i)),date(ntv(i)),the1,the2,the3,
     &            resd,v2,v23)
               resd=resd*p00(date(nvl(i)),date(nti(i)),the1,the2,the3)
                   if(dv(i).eq.1)then
                      resd=resd*dut3(ntv(i))*v2*vv24
                   endif
                   call p03(date(nti(i)),date(ntv(i)),the1,the2,the3,
     &            rese,v1,v2,v3,v13,v23)
               rese=rese*p00(date(nvl(i)),date(nti(i)),the1,the2,the3)
                   if(dv(i).eq.1)then
                      rese=rese*dut3(ntv(i))*v3*vv34
                   endif
                  call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &            resf1,v1,v13)
                  call p13(date(nti(i)),date(ntv(i)),the2,the3,resf2,
     &                  v1,v3,v13)
                  resf=resf1*resf2
                   if(dv(i).eq.1)then
                      resf=resf*dut3(ntv(i))*v3*vv34
                   endif
                   res1 = dlog(resa*(resb+resc+resd+rese+resf))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,the3)
                      resa = resa*dut2(nti(i))*vv02*p22(date(nti(i)),
     &               date(nvl(i)),the1,the3,v2,v23)
                      resb =p22(date(nvl(i)),date(ntv(i))
     &                     ,the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2*vv24
                      endif
                      resc = 0.d0
                      if(nvl(i).lt.ntv(i))then
                         call p23(date(nvl(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                         if(dv(i).eq.1)then
                          resc=resc*dut3(ntv(i))*v3*vv34
                         endif
                      endif   
                      res1 = dlog(resa*(resb+resc))
                   else
c                         institutionalise apres vl
                      resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                      resb=p00(date(nvl(i)),date(nti(i)),the1,the2,the3)
                      resb = resb*dut2(nti(i))*vv02*p22(date(nti(i)),
     &               date(ntv(i)),the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2*vv24
                      endif
                      call p23(date(nti(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2
     &                ,the3)*dut2(nti(i))*vv02
                      if(dv(i).eq.1)then
                         resc=resc*dut3(ntv(i))*v3*vv34
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resd,v1,v13)
                      resd=resd*dut2(nti(i))*v13*vv13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resd=resd*dut3(ntv(i))*v3*vv34
                      endif
                      res1 = dlog(resa*(resb+resc+resd))
                   endif   
                endif
             else
c              diagnostique dement
                if(di(i).eq.0)then
c                  pas institutionalise
                   call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resa,v1,v13)
                   resa=resa*p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &              the3)*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                   resb=p11(date(nti(i)),date(ntv(i)),the2,the3,
     &                  v1,v13)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))*v1*vv14
                   endif
                   call p13(date(nti(i)),date(ntv(i)),the2,the3,resc,
     &                  v1,v3,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v3*vv34
                   endif
                   res1=dlog(resa*(resb+resc))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,
     &            the3)*dut2(nti(i))*vv02*
     &               p22(date(nti(i)),date(nvl(i)),
     &               the1,the3,v2,v23)
                      call p23(date(nvl(i)),date(nvj(i)),the1,the3,
     &                resb,v2,v3,v23)
                      resa=resa*resb*p33(date(nvj(i)),date(ntv(i)),
     &                 the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3*vv34
                      endif
                      res1=dlog(resa)
                   else
                      if(nti(i).le.nvj(i))then
c                         institutionalise entre vl et vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &      the3)*p33(date(nvj(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3*vv34
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resb=resb*dut2(nti(i))*v13*vv13*
     &                p33(date(nti(i)),date(nvj(i)),the3,v3)
                      call p23(date(nti(i)),date(nvj(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2,
     &                     the3)*dut2(nti(i))*vv02
                         res1=dlog(resa*(resb+resc))
                      else
c                         institutionalise apres vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &        the3)
                      call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resa=resa*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                      resa=resa*dut2(nti(i))*v13*vv13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3*vv34
                      endif
                          res1=dlog(resa*resb)
                      endif
                   endif   
                endif
             endif   
             res = res + res1  
 20       continue   

c          write(*,*)'res',res

c---------- calcul de la penalisation -------------------

         pe1 = 0.d0
         pe2 = 0.d0
         pe3 = 0.d0
         do 24 i=1,nz1-1
            pe1 = pe1+(the1(i-3)*the1(i-3)*m3m3a(i))+(the1(i-2)
     &    *the1(i-2)*m2m2a(i))+(the1(i-1)*the1(i-1)*m1m1a(i))+(
     &    the1(i)*the1(i)*mmma(i))+(2.d0*the1(i-3)*the1(i-2)*
     &    m3m2a(i))+(2.d0*the1(i-3)*the1(i-1)*m3m1a(i))+(2.d0*
     &    the1(i-3)*the1(i)*m3ma(i))+(2.d0*the1(i-2)*the1(i-1)*
     &    m2m1a(i))+(2.d0*the1(i-2)*the1(i)*m2ma(i))+(2.d0*the1(i-1)
     &    *the1(i)*m1ma(i))
 24      continue
         do 25 i=1,nz2-1
            pe2 = pe2+(the2(i-3)*the2(i-3)*m3m3b(i))+(the2(i-2)
     &    *the2(i-2)*m2m2b(i))+(the2(i-1)*the2(i-1)*m1m1b(i))+(
     &    the2(i)*the2(i)*mmmb(i))+(2.d0*the2(i-3)*the2(i-2)*
     &    m3m2b(i))+(2.d0*the2(i-3)*the2(i-1)*m3m1b(i))+(2.d0*
     &    the2(i-3)*the2(i)*m3mb(i))+(2.d0*the2(i-2)*the2(i-1)*
     &    m2m1b(i))+(2.d0*the2(i-2)*the2(i)*m2mb(i))+(2.d0*the2(i-1)
     &    *the2(i)*m1mb(i))
 25      continue
         do 30 i=1,nz3-1
            pe3 = pe3+(the3(i-3)*the3(i-3)*m3m3c(i))+(the3(i-2)
     &    *the3(i-2)*m2m2c(i))+(the3(i-1)*the3(i-1)*m1m1c(i))+(
     &    the3(i)*the3(i)*mmmc(i))+(2.d0*the3(i-3)*the3(i-2)*
     &    m3m2c(i))+(2.d0*the3(i-3)*the3(i-1)*m3m1c(i))+(2.d0*
     &    the3(i-3)*the3(i)*m3mc(i))+(2.d0*the3(i-2)*the3(i-1)*
     &    m2m1c(i))+(2.d0*the3(i-2)*the3(i)*m2mc(i))+(2.d0*the3(i-1)
     &    *the3(i)*m1mc(i))
 30      continue
          pe = k0(1)*pe1 + k0(2)*pe2+ k0(3)*pe3 
c                write(*,*)'res pe',res,pe
          res = res - pe
          funcpa = res
          return
          end
c========================          P00         ====================
      double precision function p00(a,b,the1,the2,the3)
         double precision a,b,the1(-2:20),the2(-2:20),the3(-2:20)
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision res
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision su01a,ri01a,su01b,ri01b
         double precision su02a,ri02a,su02b,ri02b
         double precision su04a,ri04a,su04b,ri04b
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34

         if (a.eq.b)then
           p00 = 1.d0
         else 
           call susp(a,the1,nz1,su01a,ri01a,zi1)
           call susp(b,the1,nz1,su01b,ri01b,zi1)
           call susp(a,the2,nz2,su02a,ri02a,zi2)
           call susp(b,the2,nz2,su02b,ri02b,zi2)
           call susp(a,the3,nz3,su04a,ri04a,zi3)
           call susp(b,the3,nz3,su04b,ri04b,zi3)
cc           res = (su01b*su02b*su04b)/(su01a*su02a*su04a)
           res = ((su01b/su01a)**vv01)*((su02b/su02a)**vv02)
           res = res*((su04b/su04a)**vv04)
           p00 = res
         endif 
         return
         end
c========================          P11         ====================
      double precision function p11(a,b,the2,the3,v1,v13)
         double precision a,b,v1,v13,the2(-2:20),the3(-2:20)
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision res
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision su02a,ri02a,su02b,ri02b
         double precision su04a,ri04a,su04b,ri04b
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34

         if (a.eq.b)then
           p11 = 1.d0
         else 
           call susp(a,the2,nz2,su02a,ri02a,zi2)
           call susp(b,the2,nz2,su02b,ri02b,zi2)
           call susp(a,the3,nz3,su04a,ri04a,zi3)
           call susp(b,the3,nz3,su04b,ri04b,zi3)
           res=((su02b/su02a)**(v13*vv13))*((su04b/su04a)**(v1*vv14))
           p11 = res
         endif  
         return
         end
c========================          P22         ====================
      double precision function p22(a,b,the1,the3,v2,v23)
         double precision a,b,v2,v23,the1(-2:20),the3(-2:20)
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision res
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision su01a,ri01a,su01b,ri01b
         double precision su04a,ri04a,su04b,ri04b
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34

         if (a.eq.b)then
           p22 = 1.d0
         else 
           call susp(a,the1,nz1,su01a,ri01a,zi1)
           call susp(b,the1,nz1,su01b,ri01b,zi1)
           call susp(a,the3,nz3,su04a,ri04a,zi3)
           call susp(b,the3,nz3,su04b,ri04b,zi3)
           res=((su01b/su01a)**(v23*vv23))*((su04b/su04a)**(v2*vv24))
           p22 = res
         endif  
         return
         end
c========================          P33         ====================
      double precision function p33(a,b,the3,v3)
         double precision a,b,v3,the3(-2:20)
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision res
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision su04a,ri04a,su04b,ri04b
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34

         if (a.eq.b)then
            p33 = 1.d0
         else 
            call susp(a,the3,nz3,su04a,ri04a,zi3)
            call susp(b,the3,nz3,su04b,ri04b,zi3)
            res = (su04b/su04a)**(v3*vv34)
            p33 = res
         endif
         return
         end
c================================  P01   ==========================
      subroutine p01(a,b,the1,the2,the3,res,v1,v13)
         double precision a,b,the1(-2:20),the2(-2:20),the3(-2:20)
         double precision dx,xm,xr,w(5),x(5),res,v1,v13
         double precision xx,f1,su01,ri01,f2
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision p00,p11
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j
         

         if (a.eq.b)then
            res = 0.d0
         else   
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
               call susp(xx,the1,nz1,su01,ri01,zi1)
               f1=p00(a,xx,the1,the2,the3)*ri01*vv01*
     &            p11(xx,b,the2,the3,v1,v13)
               xx = xm-dx
               call susp(xx,the1,nz1,su01,ri01,zi1)
               f2=p00(a,xx,the1,the2,the3)*ri01*vv01*
     &            p11(xx,b,the2,the3,v1,v13)
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   
  

         end
c================================  P02   ==========================
      subroutine p02(a,b,the1,the2,the3,res,v2,v23)
         double precision a,b,the1(-2:20),the2(-2:20),the3(-2:20)
         double precision dx,xm,xr,w(5),x(5),res,v2,v23
         double precision xx,f1,su02,ri02,f2
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision p00,p22
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j

         if (a.eq.b)then
            res = 0.d0
         else 
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
               call susp(xx,the2,nz2,su02,ri02,zi2)
               f1=p00(a,xx,the1,the2,the3)*ri02*vv02*
     &            p22(xx,b,the1,the3,v2,v23)
               xx = xm-dx
               call susp(xx,the2,nz2,su02,ri02,zi2)
               f2=p00(a,xx,the1,the2,the3)*ri02*vv02*
     &            p22(xx,b,the1,the3,v2,v23)
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   

         end
c================================  P03   ==========================
      subroutine p03(a,b,the1,the2,the3,res,v1,v2,v3,v13,v23)
         double precision a,b,the1(-2:20),the2(-2:20),the3(-2:20)
         double precision dx,xm,xr,w(5),x(5),v2,v23,v1,v3,v13
         double precision xx,f1,f2,resut,res
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision p00
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j

         if (a.eq.b)then
            res = 0.d0
         else 
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
            call put(xx,b,the1,the2,the3,resut,v1,v2,v3,v13,v23)
               f1=p00(a,xx,the1,the2,the3)*resut
               xx = xm-dx
            call put(xx,b,the1,the2,the3,resut,v1,v2,v3,v13,v23)
               f2=p00(a,xx,the1,the2,the3)*resut
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   

         end
c================================  PUT   ==========================
      subroutine put(a,b,the1,the2,the3,res,v1,v2,v3,v13,v23)
         double precision the1(-2:20),the2(-2:20),the3(-2:20)
         double precision a,b,dx,xm,xr,w(5),x(5),res,v2,v3
         double precision xx,f1,su01,ri01,p22,p33,f2,p11,v23
         double precision fa,fb,su02,ri02,su13,ri13,v1,v13
         double precision su23,ri23
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j
         
         if (a.eq.b)then
            res = 0.d0
         else 
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            call susp(a,the1,nz1,su01,ri01,zi1)
            call susp(a,the2,nz2,su02,ri02,zi2)
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
               call susp(xx,the2,nz2,su13,ri13,zi2)
               fa=ri01*vv01*p11(a,xx,the2,the3,v1,v13)*ri13*v13*vv13
               call susp(xx,the1,nz1,su23,ri23,zi1)
               fb=ri02*vv02*p22(a,xx,the1,the3,v2,v23)*ri23*v23*vv23
               f1=(fa+fb)*p33(xx,b,the3,v3)
               xx = xm-dx
               call susp(xx,the2,nz2,su13,ri13,zi2)
               fa=ri01*vv01*p11(a,xx,the2,the3,v1,v13)*ri13*v13*vv13
               call susp(xx,the1,nz1,su23,ri23,zi1)
               fb=ri02*vv02*p22(a,xx,the1,the3,v2,v23)*ri23*v23*vv23
               f2=(fa+fb)*p33(xx,b,the3,v3)
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   
  

         end

c================================  P13   ==========================
      subroutine p13(a,b,the2,the3,res,v1,v3,v13)
         double precision a,b,the2(-2:20),the3(-2:20)
         double precision dx,xm,xr,w(5),x(5),res,v1,v3,v13
         double precision xx,f1,su02,ri02,p11,p33,f2
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j
         
         if (a.eq.b)then
            res = 0.d0
         else 
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
               call susp(xx,the2,nz2,su02,ri02,zi2)
          f1=p11(a,xx,the2,the3,v1,v13)*ri02*v13*vv13*p33(xx,b,the3,v3)
               xx = xm-dx
               call susp(xx,the2,nz2,su02,ri02,zi2)
          f2=p11(a,xx,the2,the3,v1,v13)*ri02*v13*vv13*p33(xx,b,the3,v3)
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   
  

         end


c================================  P23   ==========================
      subroutine p23(a,b,the1,the3,res,v2,v3,v23)
         double precision a,b,the1(-2:20),the3(-2:20)
         double precision dx,xm,xr,w(5),x(5),res,v2,v3,v23
         double precision xx,f1,su01,ri01,p22,p33,f2
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         common /dace1/zi1,zi2,zi3
         integer nz1,nz2,nz3,ndate
         common /dace3/ndate,nz1,nz2,nz3
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         save w,x
         data w/0.2955242247d0,0.2692667193d0,0.2190863625d0,
     &          0.1494513491d0,0.0666713443d0/
         data x/0.1488743389d0,0.4333953941d0,0.6794095682d0,
     &          0.8650633666d0,0.9739065285d0/
         integer j
         
         if (a.eq.b)then
            res = 0.d0
         else 
            xm = 0.5d0*(b+a)
            xr = 0.5d0*(b-a)
            res = 0.d0
            do 11 j=1,5
               dx=xr*x(j)
               xx = xm+dx
               call susp(xx,the1,nz1,su01,ri01,zi1)
          f1=p22(a,xx,the1,the3,v2,v23)*ri01*v23*vv23*p33(xx,b,the3,v3)
               xx = xm-dx
               call susp(xx,the1,nz1,su01,ri01,zi1)
          f2=p22(a,xx,the1,the3,v2,v23)*ri01*v23*vv23*p33(xx,b,the3,v3)
               res = res + w(j)*(f1+f2)
 11         continue
            res = res*xr
         endif   
  

         end




c================================  DCHOLE  ===========================
      subroutine dchole(a,k,nq,idpos)
      double precision a(5000),term,xn,diag,p
      dimension is(200)
      equivalence (term,xn)
      integer k,nq,i,ii,i1,i2,i3,m,is,j,k2,jmk
      integer ijm,irm,jji,jjj,l,jj,iil,jjl,il,idpos
c
c
c      ss programme de resolution d'un systeme lineaire symetrique
c
c
c       k ordre du systeme /
c       nq nombre de seconds membres
c
c       en sortie les seconds membres sont remplaces par les solutions
c       correspondantes
c
      idpos=0
      k2=k+nq
c     calcul des elements de la matrice
      do 13 i=1,k
      ii=i*(i+1)/2
c       elements diagonaux
      diag=a(ii)
      i1=ii-i
      if(i-1) 1,4,1
1     i2=i-1
      do 3 l=1,i2
      m=i1+l
      p=a(m)
      p=p*p
      if(is(l)) 2,3,3
2     p=-p
3     diag=diag-p
4     if(diag) 5,50,6
5     is(i)=-1
      idpos=idpos+1
      diag=-dsqrt(-diag)
      a(ii)=-diag
      go to 7
6     is(i)=1
      diag=dsqrt(diag)
      a(ii)=diag
c       elements non diagonaux
7     i3=i+1
      do 13 j=i3,k2
      jj=j*(j-1)/2+i
      jmk=j-k-1
      if(jmk) 9,9,8
8     jj=jj-jmk*(jmk+1)/2
9     term=a(jj)
      if(i-1) 10,13,10
10    do 12 l=1,i2
      iil=ii-l
      jjl=jj-l
      p=a(iil)*a(jjl)
      il=i-l
      if(is(il)) 11,12,12
11    p=-p
12    term=term-p
13    a(jj)=term/diag
c       calcul des solutions
      jj=ii-k+1
      do 45 l=1,nq
      jj=jj+k
      i=k-1
14    jji=jj+i
      xn=a(jji)
      if(i-k+1) 20,22,22
20    j=k-1
21    jjj=jj+j
      ijm=i+1+j*(j+1)/2
      xn=xn-a(jjj)*a(ijm)
      if(j-i-1) 22,22,30
30    j=j-1
      go to 21
22    irm=(i+1)*(i+2)/2
      a(jji)=xn/a(irm)
      if(i) 45,45,40
40    i=i-1
      go to 14
45    continue
50    continue
      return 
      end


c=================================    DERIVA    =======================

      subroutine deriva(b,m,v,rl,k0)

      double precision funcpa,thn,th,z,rl,b(70),v(5000),vl
      double precision fcith(70),th2,k0(3)
      integer i0,iun,m,m1,ll,i,k,j

c
c     v:matrice d'information+score
c     calcul de la derivee premiere
c
c     - la hessienne et derivee premiere

      th=1.d-5
      thn=-th
      th2=th*th
      z=0.d0
      i0=0
      iun =1
      rl=funcpa(b,m, iun,z,iun,z,k0)
      do 2 i=1,m
	    fcith(i)=funcpa(b,m ,i,th,i0,z,k0)
2     continue
      k=0
      m1=m*(m+1)/2
      ll=m1
      do 1 i=1,m
      ll=ll+1
      vl=(fcith(i)-funcpa( b,m, i,thn,i0,z,k0))/(2.d0*th)
      v(ll)=vl
      do 1 j=1,i
      k=k+1
      v(k)=-(funcpa( b,m, i,th,j,th,k0)-fcith(j)-fcith(i)+rl)/th2
1     continue
      return
      end


c================================  DMFSD  ===================================

      SUBROUTINE DMFSD(A,N,EPS,IER)
C
C   FACTORISATION DE CHOLESKY D'UNE MATRICE SDP
C   MATRICE = TRANSPOSEE(T)*T
C   ENTREE : TABLEAU A CONTENANT LA PARTIE SUPERIEURE STOCKEE COLONNE
C            PAR COLONNE DE LA METRICE A FACTORISER
C   SORTIE : A CONTIENT LA PARTIE SUPPERIEURE DE LA MATRICE SYMETRIQUE T
C 
C   SUBROUTINE APPELE PAR DSINV
C  
C   N : DIM. MATRICE 
C   EPS : SEUIL DE TOLERANCE
C   IER = 0 PAS D'ERREUR
C   IER = -1 ERREUR
C   IER = K COMPRIS ENTRE 1 ET N, WARNING, LE CALCUL CONTINUE
C
      DOUBLE PRECISION A(N*(N+1)/2)
      DOUBLE PRECISION DPIV,DSUM
      DOUBLE PRECISION EPS,TOL
      INTEGER I,K,L,N,IER,KPIV,IND,LEND,LANF,LIND
C
C   TEST ON WRONG INPUT PARAMETER N
C
      IF(N-1) 12,1,1
1     IER=0
C
C   INITIALIZE DIAGONAL-LOOP
C
      KPIV=0
      DO 11 K=1,N
      KPIV=KPIV+K
      IND=KPIV
      LEND=K-1
C
C   CALCULATE TOLERANCE
C
      TOL=DABS(EPS*SNGL(A(KPIV)))
C
C   START FACTORIZATION-LOOP OVER K-TH ROW
C
      DO 11 I=K,N
      DSUM=0.D0
      IF(LEND) 2,4,2
C
C   START INNER LOOP
C
2     DO 3 L=1,LEND
      LANF=KPIV-L
      LIND=IND-L
3     DSUM=DSUM+A(LANF)*A(LIND)
C
C   END OF INNEF LOOP
C
C   TRANSFORM ELEMENT A(IND)
C
4     DSUM=A(IND)-DSUM
      IF(I-K)10,5,10
C
C   TEST FOR NEGATIVE PIVOT ELEMENT AND FOR LOSS OF SIGNIFICANCE
C
5     IF(SNGL(DSUM)-TOL)6,6,9
6     IF(DSUM)12,12,7
7     IF(IER)8,8,9
8     IER=K-1
C
C   COMPUTE PIVOT ELEMENT
C
9     DPIV=DSQRT(DSUM)
      A(KPIV)=DPIV
      DPIV=1.D0/DPIV
      GO TO 11
C
C   CALCULATE TERMS IN ROW
C
10    A(IND)=DSUM*DPIV
11    IND=IND+I
C
C   END OF DIAGONAL-LOOP
C
      RETURN
12    IER=-1
      RETURN
 
      END

c==============================   DSINV  ======================================

      SUBROUTINE DSINV(A,N,EPS,IER)
C
C     INVERSION D'UNE MATRICE SYMETRIQUE DEFINIE POSITIVE :
C
C     MATRICE = TRANSPOSEE(T)*T
C     INERSE(MATRICE) = INVERSE(T)*INVERSE(TRANSPOSEE(T))
C
C     A : TABLEAU CONTENANT LA PARTIE SUPERIEURE DE LA MATRICE A INVERSER
C         STOCKEE COLONNE PAR COLONNE
C     DIM. MATRICE A INVERSER = N 
C     DIM. TABLEAU A = N*(N+1)/2
C
C     EPS : SEUIL DE TOLERANCE AU-DESSOUS DUQUEL UN PIVOT EST CONSIDERE
C           COMME NUL
C
C     IER : CODE D'ERREUR
C         IER=0 PAS D'ERREUR
C         IER=-1 ERREUR SUR LA DIM.N OU MATRICE PAS DEFINIE POSITIVE
C         IER=1 PERTE DE SIGNIFICANCE, LE CALCUL CONTINUE
C
      DOUBLE PRECISION A(N*(N+1)/2)
      DOUBLE PRECISION DIN,WORK
      DOUBLE PRECISION EPS
      INTEGER N,IER,IND,IPIV,I,J,K,L,MIN,KEND
      INTEGER LHOR,LVER,LANF
C
C     FACTORIZE GIVEN MATRIX BY MEANS OF SUBROUTINE DMFSD
C     A=TRANSPOSE(T) * T
C
      CALL DMFSD(A,N,EPS,IER)
      IF(IER) 9,1,1
C
C     INVERT UPPER TRIANGULAR MATRIX T
C     PREPARE INVERSION-LOOP
C
1     IPIV=N*(N+1)/2
      IND=IPIV
C
C     INITIALIZE INVERSION-LOOP
C
      DO 6 I=1,N
      DIN=1.D0/A(IPIV)
      A(IPIV)=DIN
      MIN=N
      KEND=I-1
      LANF=N-KEND
      IF(KEND) 5,5,2
2     J=IND
C
C     INITIALIZE ROW-LOOP
C
      DO 4 K=1,KEND
      WORK=0.D0
      MIN=MIN-1
      LHOR=IPIV
      LVER=J
C
C     START INNER LOOP
C
      DO 3 L=LANF,MIN
      LVER=LVER+1
      LHOR=LHOR+L
3     WORK=WORK+A(LVER)*A(LHOR)
C
C     END OF INNER LOOP
C
      A(J)=-WORK*DIN
4     J=J-MIN
C
C     END OF ROW-LOOP
C
5     IPIV=IPIV-MIN
6     IND=IND-1
C
C     END OF INVERSION-LOOP
C
C     CALCULATE INVERSE(A) BY MEANS OF INVERSE(T)
C     INVERSE(A) = INVERSE(T) * TRANSPOSE(INVERSE(T))
C     INITIALIZE MULTIPLICATION-LOOP
C
      DO 8 I=1,N
      IPIV=IPIV+I
      J=IPIV
C
C     INITIALIZE ROW-LOOP
C
      DO 8 K=I,N
      WORK=0.D0
      LHOR=J
C
C     START INNER LOOP
C
      DO 7 L=K,N
      LVER=LHOR+K-I
      WORK=WORK+A(LHOR)*A(LVER)
7     LHOR=LHOR+L
C
C     END OF INNER LOOP
C
      A(J)=WORK
8     J=J+K
C
C     END OF ROW-AND MULTIPLICATION-LOOP
C
9     RETURN
 
      END

c===============================    MAXT    =============================

      DOUBLE PRECISION FUNCTION MAXT(DELTA,M)
      DOUBLE PRECISION DELTA(M)
      INTEGER I,M
c
      MAXT=DELTA(1)
      DO 2 I=2,M
      IF(DELTA(I).GT.MAXT) MAXT=DELTA(I)
2     CONTINUE
      RETURN
      END

c===============================  MARQ98    =============================

   	 subroutine marq98(k0,b,m,ni,v,hes,rl,ier,istop)
c
c  newr93 : version de newton avec pas optimum si vrais non augmentee
c
c  fu = matrice des derivees secondes et premieres
c
c  istop: raison de l'arret
c  1: evolution des parametres (ca)
c  2: evolution de la logvraisemblance  (cb);tests de wald non valables
c  3: echec resolution systeme lineaire  (ier=1)
c  4: echec calcul derivees
c
       double precision fu(5000),da,dm,ga,tr
       double precision b(70),v(5000),delta(100),ca,cb,epsa,epsb,rl,eps
       double precision funcpa,k0(3),hes(71,71)
       double precision b1(70),vw,fi,maxt,z,bh(100),rl1,th,step,ep,dd
       integer m,ni,nq,i,ii,nfmax,idpos,ier,istop,igrad,ncount,jj
       integer j,kkk,k


       do 119 jj=1,m
          delta(jj) = 0.d0
 119   continue
   
       z=0.d0
       th=1.d-5
       eps=1.d-7
       epsa=1.d-5  
       epsb=1.d-5
       nfmax=m*(m+1)/2
       ca=epsa+1.d0
       cb=epsb+1.d0
       rl1=-1.d+10
       ni=0
       istop=0
       da=0.01d0
       ga=0.d0
       dm=5.d0
c  nq=nbre de seconds membres pour chole
       nq=1
10     continue
c       
cc       write(6,*)
cc             write(6,1011) ni 
cc          write(6,*)'da',da,' ga=',ga


1011      format(1x,' iteration',i4)
c          write(6,*) 'vw =',vw  
          call deriva(b,m,v,rl,k0)
          rl1=rl 
c
          dd = 0.d0
          do 13 i=m*(m+1)/2+1,m*(m+3)/2
             dd = dd + v(i)*v(i)
 13       continue 

c          write(6,*) (b(ii),ii=1,m)
          if (ca.lt.epsa.and.cb.lt.epsb.and.dd.lt.1.d-3) goto 100
c
          do 1 i=1,nfmax+m
             fu(i)=v(i)
c            write(6,*) 'derivee',v(i)
1         continue
c
          tr=0.d0
          do 300 i=1,m
             ii=i*(i+1)/2
             tr=tr+dabs(v(ii))
 300      continue
          tr=tr/dble(m)
c
          ncount=0
          ga=0.01d0
 400      do 500 i=1,m
             ii=i*(i+1)/2
             if (v(ii).ne.0) then
             fu(ii)=v(ii)+da*((1.d0-ga)*dabs(v(ii))+ga*tr)
             else
             fu(ii)=da*ga*tr
             endif
 500      continue
          call dchole(fu,m,nq,idpos)
c
          if (idpos.ne.0) then  
cc             write(6,*) 'echec inversion choleski'
             da=dm*da
             ncount=ncount+1
             if (ncount.le.3) then
                da=da*dm
             else
                ga=ga*dm
                if (ga.gt.1.d0) ga=1.d0
             goto 400
             endif
          else
cc              write(6,*) 'matrice reguliere'
              do 2 i=1,m
                 delta(i)=fu(nfmax+i)
                 b1(i)=b(i)+delta(i)
c                 write(6,*) delta(i),b(i)
2             continue
              rl=funcpa(b1,m,0,z,0,z,k0)
cc              write(6,*) 'rl1 =',rl1,' rl =',rl
              igrad=1
              if (rl1.lt.rl) then
                 if(da.lt.eps) then
                    da=eps
                 else
                    da=da/(dm+2.d0)
                 endif
                 goto 800
              endif
           endif
cc           write(6,*) ' non amelioration de la vraisemblance '
           if(dabs(maxt(delta,m)).eq.0.d0) then
              vw=th
           else
              vw=th/dabs(maxt(delta,m)) 
           endif
c           
           step=dlog(1.5d0)

           call searpas(vw,step,b,bh,m,delta,fi,eps,k0)

           rl=-fi
cc           write(6,*) 'rl1 =',rl1,' rl =',rl
           do 4 i=1,m
              delta(i)=vw*delta(i)
 4         continue
           da=(dm-3.d0)*da  
c
 800       cb=dabs(rl1-rl)
           ca=0.d0
           do 5 i=1,m
              ca=ca+(dexp(b(i))*(1.d0-dexp(delta(i))))**2
 5         continue
cc           write(6,*) 'ca =',ca,' cb =',cb,' dd =',dd,' igrad =',igrad
cc          write(6,*) rl
c     
           do 6 i=1,m
              b(i)=b(i)+delta(i)
 6         continue
c     
           ni=ni+1
           if (ni.gt.100) then
              istop=-10
              write(6,*) 'nombre iteration max atteinte'
              goto 110
           end if
           goto 10
c********************
c     inversion matrice d'information
c********************
100      continue
           call deriva(b,m,v,rl,k0)
           ep=10.d-10

           kkk=m*(m+1)/2
          do 3005 i=1,m
              kkk = kkk+1
             do 3004 j=i,m
                k = (((j-1)*j)/2) +i
                hes(i,j)= v(k)/(4.d0*b(i)*b(j))
 3004        continue
             hes(i,i)= hes(i,i)+(v(kkk)/(4.d0*b(i)*b(i)*b(i)))
c         write(*,*)i,hes(i,i),(v(kkk)/(4.d0*b(i)*b(i)*b(i)))
 3005        continue
c             write(*,*)v(1),b(1),v(1+m*(m+1)/2)
c             write(*,*)hes(1,2),hes(1,3),hes(1,4),hes(1,5)
c             write(*,*)hes(1,6),hes(1,7),hes(1,8),hes(1,9)
c           write(*,*)hes(1,10),hes(1,11),hes(1,12),hes(1,13)
c           write(*,*)hes(1,19),hes(1,20),hes(1,21),hes(1,22)
        do  3007 i = 2,m
            do 3006 j = 1,i-1
               hes(i,j)=hes(j,i)
 3006       continue
 3007    continue

           call dsinv(v,m,ep,ier)
           if (ier.ne.0) then
             write(6,103)          
103          format(1x,'echec inversion matrice information')
             istop=3
           endif

c           do 104 i=1,m
c              ii=i*(i+1)/2
c              write(6,*) 'variance parametre',i,' = ',v(ii)
c104        continue
c           write(6,*)
c           ii=0
c           do 105 i=m*(m+1)/2+1,m*(m+3)/2
c           ii=ii+1
c           write(6,*)'probleme'
c           write(6,*) 'derivee premiere % parametre',ii,' = ',v(i)
c105        continue
           istop=1
110    continue
       return
       end


c=================================  SEARPAS    ==============================

      SUBROUTINE SEARPAS(VW,STEP,B,BH,M,DELTA,FIM,EPSV,k0)
C
C  MINIMISATION UNIDIMENSIONNELLE
C
       INTEGER I,M
       DOUBLE PRECISION VLW,VLW1,VLW2,VLW3,VW,VM,B(M),k0(3)
       DOUBLE PRECISION FI1,FI2,FI3,FIM,EPSV,BH(M),DELTA(M)
       DOUBLE PRECISION STEP
C     
C
       VLW1=DLOG(VW)
       VLW2=VLW1+STEP
       CALL VALFPA(VLW1,FI1,B,BH,M,DELTA,k0)
       CALL VALFPA(VLW2,FI2,B,BH,M,DELTA,k0)
C
       IF(FI2.GE.FI1) THEN
          VLW3=VLW2
          VLW2=VLW1
          FI3=FI2
          FI2=FI1
C
          STEP=-STEP
C
          VLW1=VLW2+STEP
          CALL VALFPA(VLW1,FI1,B,BH,M,DELTA,k0)   
          IF (FI1.GT.FI2) GOTO 50
       ELSE
          VLW=VLW1
          VLW1=VLW2
          VLW2=VLW
       ENDIF
C
       DO 20 I=1,40
          VLW3=VLW2
          VLW2=VLW1
          FI3=FI2
          FI2=FI1
C
          VLW1=VLW2+STEP
          CALL VALFPA(VLW1,FI1,B,BH,M,DELTA,k0)
          IF(FI1.GT.FI2) GO TO 50
c          IF (dabs(FI1-FI2).LT.EPSV) THEN
          IF (FI1.eq.FI2) THEN
             FIM=FI2
             VM=VLW2
             GO TO 100
          ENDIF
 20    CONTINUE
C
C  PHASE 2 APPROXIMATION PAR QUADRIQUE
C
50     CONTINUE
C
C  CALCUL MINIMUM QUADRIQUE
C
         VM=VLW2-STEP*(FI1-FI3)/(2.d0*(FI1-2.d0*FI2+FI3))
         CALL VALFPA(VM,FIM,B,BH,M, DELTA,k0)
         IF (FIM.LE.FI2) GO TO 100
         VM=VLW2
         FIM=FI2
100   CONTINUE
      VW=DEXP(VM)
      RETURN

      END


c===================================   VALFPA    ==============================

        subroutine valfpa(vw,fi,b,bk,m,delta,k0)
        double precision vw,fi,delta(m),bk(m)
        double precision funcpa,b(70),z
        integer m,i

         double precision k0(3)

c   

         z=0.d0
         do 1 i=1,m
            bk(i)=b(i)+dexp(vw)*delta(i)
1        continue
c
         fi=-funcpa(bk,m,1,z,1,z,k0)
c
         return
         end   
       
       

c==========================  DISTANCE   =================================
       subroutine distance(nz1,nz2,nz3,hes,b,nomfich01,nomfich02,
     &      nomfich04,nomfich14,nomfich24,nomfich34,nomfich13,nomfich23)
         double precision the1(-2:20),the2(-2:20),the3(-2:20),b(70)
         double precision x1,x2,x3,h1,h2,h3,hes(71,71),h(71,71),y(71,71)
         double precision hes1(25,25),hes2(25,25),hes3(25,25)
         double precision su,bsup,binf,lam,lbinf,lbsup,d
         double precision su1,ri1,su2,ri2,su3,ri3
         double precision v1,v2,v3,v13,v23
         integer nz1,nz2,nz3,i,j,n,np,k,l,indx(71)
         character*14 nomfich01,nomfich02,nomfich04
         character*14 nomfich14,nomfich24,nomfich34,nomfich13
         character*14 nomfich23
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         common /dace1/zi1,zi2,zi3


         n  = nz1+2+nz2+2+nz3+2
         v1 = dexp(b(nz1+2+nz2+2+nz3+2+1))
         v2 = dexp(b(nz1+2+nz2+2+nz3+2+2))
         v3 = dexp(b(nz1+2+nz2+2+nz3+2+3))
         v13= dexp(b(nz1+2+nz2+2+nz3+2+4))
         v23= dexp(b(nz1+2+nz2+2+nz3+2+5))
         do 100 i = 1,n
            do 90 j = 1,n
               h(i,j) = -hes(i,j)
 90         continue   
 100     continue

         np = n
         do 112 i=1,n
            do 111 j=1,n
               y(i,j)=0.d0
 111        continue
            y(i,i)=1.d0
 112     continue
         call ludcmp(h,n,np,indx,d)

         do 113 j=1,n
            call lubksb(h,n,np,indx,y(1,j))
 113     continue

         do 116 i=1,nz1+2
            do 115 j=1,nz1+2
               hes1(i,j)=y(i,j)
 115        continue
 116     continue   


         k = 0
         do 118 i=nz1+3,nz1+2+nz2+2
            k = k + 1 
            l = 0
            do 117 j=nz1+3,nz1+2+nz2+2
               l = l + 1
               hes2(k,l)=y(i,j)
 117        continue
 118     continue   


         k = 0
         do 120 i=nz1+2+nz2+3,nz1+2+nz2+2+nz3+2
            k = k + 1
            l = 0
            do 119 j=nz1+2+nz2+3,nz1+2+nz2+2+nz3+2
               l = l + 1
               hes3(k,l)=y(i,j)
 119        continue
 120     continue   


         do 4 i=1,nz1+2
            the1(i-3)=(b(i))*(b(i))
 4       continue
        do 6 i=1,nz2+2
            j = nz1+2+i
            the2(i-3)=(b(j))*(b(j))
 6       continue
        do 8 i=1,nz3+2
            j = nz1+2+nz2+2+i
            the3(i-3)=(b(j))*(b(j))
 8       continue

         h1 = (zi1(nz1)-zi1(1))*0.01d0
         x1 = zi1(1)
         h2 = (zi2(nz2)-zi2(1))*0.01d0
         x2 = zi2(1)
         h3 = (zi3(nz3)-zi3(1))*0.01d0
         x3 = zi3(1)

         write(*,*)' '
         write(*,*)' '
         write(*,*)'------------ sortie de 8 fichiers ---------- '
         write(*,*)' '
         write(*,*)nomfich01,nomfich02,nomfich04,nomfich14
         write(*,*)nomfich24,nomfich34,nomfich13,nomfich23
         write(*,*)' '
         write(*,*)'comprenant t, surv(t), lambda(t) et sa BDC'
         write(*,*)'------------- fin sortie ------------ '
         open(11,file=nomfich01)
         open(12,file=nomfich02)
         open(13,file=nomfich04)
         open(14,file=nomfich14)
         open(15,file=nomfich24)
         open(16,file=nomfich34)
         open(17,file=nomfich13)
         open(18,file=nomfich23)
         do 10 i=1,99
            x1 = x1 + h1 
             call cosp(x1,the1,nz1+2,hes1,zi1,binf,su1,bsup
     &    ,lbinf,ri1,lbsup)
               if(binf.lt.0.d0)then
                 binf = 0.d0
               endif
               if(bsup.gt.1.d0)then
                 bsup = 1.d0
               endif
              if(lbinf.lt.0.d0)then
                 lbinf = 0.d0
              endif
        write(11,*)real(x1),real(su1),real(ri1),real(lbinf),real(lbsup)
            x2 = x2 + h2 
            call cosp(x2,the2,nz2+2,hes2,zi2,binf,su2,bsup
     &   ,lbinf,ri2,lbsup)
               if(binf.lt.0.d0)then
                 binf = 0.d0
               endif
               if(bsup.gt.1.d0)then
                 bsup = 1.d0
               endif
              if(lbinf.lt.0.d0)then
                 lbinf = 0.d0
              endif
        write(12,*)real(x2),real(su2),real(ri2),real(lbinf),real(lbsup)
            x3 = x3 + h3 
            call cosp(x3,the3,nz3+2,hes3,zi3,binf,su3,bsup
     &  ,lbinf,ri3,lbsup)
               if(binf.lt.0.d0)then
                 binf = 0.d0
               endif
               if(bsup.gt.1.d0)then
                 bsup = 1.d0
               endif
              if(lbinf.lt.0.d0)then
                 lbinf = 0.d0
              endif
        write(13,*)real(x3),real(su3),real(ri3),real(lbinf),real(lbsup)
            call susp(x1,the1,nz1,su1,ri1,zi1)
            call susp(x2,the2,nz2,su2,ri2,zi2)
            call susp(x3,the3,nz3,su3,ri3,zi3)
c            write(11,*)real(x1),real(su1),real(ri1)
c            write(12,*)real(x2),real(su2),real(ri2)
c            write(13,*)real(x3),real(su3),real(ri3)
            write(14,*)real(x3),real(su3**v1),real(ri3*v1)
            write(15,*)real(x3),real(su3**v2),real(ri3*v2)
            write(16,*)real(x3),real(su3**v3),real(ri3*v3)
            write(18,*)real(x1),real(su1**v23),real(ri1*v23)
            write(17,*)real(x2),real(su2**v13),real(ri2*v13)
 10      continue
         close(11)
         close(12)
         close(13)
         close(14)
         close(15)
         close(16)
         close(17)
         close(18)

         end
c======================  LUBKSB  ======================================
      subroutine lubksb(a,n,np,indx,b)
         integer n,np,indx(71)
         double precision a(71,71),b(71)
         integer i,ii,j,ll
         double precision sum

         ii = 0
         do 12 i=1,n
            ll = indx(i)
            sum = b(ll)
            b(ll) = b(i)
            if(ii.ne.0)then
               do 11 j=ii,i-1
                  sum = sum -a(i,j)*b(j)
 11            continue
            else
               if(sum.ne.0.d0)then
                  ii=i
               endif
            endif
            b(i)=sum
 12      continue
         do 14 i=n,1,-1
            sum = b(i)
            do 13 j = i+1,n
               sum = sum-a(i,j)*b(j)
 13         continue
            b(i)=sum/a(i,i)
 14      continue
         return

         end
c======================  LUDCMP  ======================================
       subroutine ludcmp(a,n,np,indx,d)
         integer n,np,indx(n),nmax
         double precision d,a(71,71),tiny
         parameter (nmax=500,tiny=1.d-20)
         integer i,imax,j,k
         double precision aamax,dum,sum,vv(nmax)

         d = 1.d0
         do 12 i=1,n
            aamax=0.d0
            do 11 j=1,n
               if (dabs(a(i,j)).gt.aamax)then
                  aamax=dabs(a(i,j))
               endif
 11         continue
            if (aamax.eq.0.d0) pause 'matrice singuliere'
            vv(i) = 1.d0/aamax
 12      continue
         do 19 j = 1,n
            do 14 i=1,j-1
               sum = a(i,j)
               do 13 k=1,i-1
                  sum = sum - a(i,k)*a(k,j)
 13            continue
               a(i,j) = sum
 14         continue
            aamax = 0.d0
            do 16 i = j,n
               sum = a(i,j)
               do 15 k=1,j-1
                  sum = sum -a(i,k)*a(k,j)
 15            continue
               a(i,j) = sum
               dum = vv(i)*dabs(sum)
               if (dum.ge.aamax) then
                  imax = i
                  aamax = dum
               endif
 16         continue
            if(j.ne.imax)then
               do 17 k=1,n
                  dum = a(imax,k)
                  a(imax,k)=a(j,k)
                  a(j,k) = dum
 17            continue
               d = -d
               vv(imax)=vv(j)
            endif
            indx(j)=imax
            if(a(j,j).eq.0.d0)then
               a(j,j)=tiny
            endif
            if(j.ne.n)then
               dum = 1.d0/a(j,j)
               do 18 i = j+1,n
                  a(i,j) = a(i,j)*dum
 18            continue
            endif
 19      continue
         return
         end
c==========================  COSP  ====================================
      subroutine cosp(x,the,n,y,zi,binf,su,bsup,lbinf,lam,lbsup)
         double precision x,ht,ht2,h2,som,lam,su,y(25,25)
         double precision binf,bsup,lbinf,lbsup,pm
         double precision htm,h2t,h3,h2n,hn,im,im1,im2,mm1,mm3
         double precision ht3,hht,h4,h3m,hh3,hh2,mm,im3,mm2
         double precision h,gl,hh,the(-2:20),zi(-2:20)
         integer j,k,n,i

         som = 0.d0
         do 58 k = 2,n-1
            if ((x.ge.zi(k-1)).and.(x.lt.zi(k)))then
               j = k-1
               if (j.gt.1)then
                  do 55 i=2,j
                     som = som+the(i-4)
 55               continue  
                endif 
            ht = x-zi(j)
            htm= x-zi(j-1)
            h2t= x-zi(j+2)
            ht2 = zi(j+1)-x
            ht3 = zi(j+3)-x
            hht = x-zi(j-2)
            h = zi(j+1)-zi(j)
            hh= zi(j+1)-zi(j-1)
            h2= zi(j+2)-zi(j)
            h3= zi(j+3)-zi(j)
            h4= zi(j+4)-zi(j)
            h3m= zi(j+3)-zi(j-1)
            h2n=zi(j+2)-zi(j-1)
            hn= zi(j+1)-zi(j-2)
            hh3 = zi(j+1)-zi(j-3)
            hh2 = zi(j+2)-zi(j-2)
            mm3 = ((4.d0*ht2*ht2*ht2)/(h*hh*hn*hh3))
            mm2 = ((4.d0*hht*ht2*ht2)/(hh2*hh*h*hn))+((-4.d0*h2t*htm
     &       *ht2)/(hh2*h2n*hh*h))+((4.d0*h2t*h2t*ht)/(hh2*h2*h*h2n))
            mm1 = (4.d0*(htm*htm*ht2)/(h3m*h2n*hh*h))+((-4.d0*htm*ht*
     &       h2t)/(h3m*h2*h*h2n))+((4.d0*ht3*ht*ht)/(h3m*h3*h2*h))
            mm  = 4.d0*(ht*ht*ht)/(h4*h3*h2*h)
            im3 = (0.25d0*(x-zi(j-3))*mm3)+(0.25d0*hh2*mm2)
     &       +(0.25d0*h3m*mm1)+(0.25d0*h4*mm)
            im2 = (0.25d0*hht*mm2)+(h3m*mm1*0.25d0)+(h4*mm*0.25d0)
            im1 = (htm*mm1*0.25d0)+(h4*mm*0.25d0)
            im  = ht*mm*0.25d0
            gl = som +(the(j-3)*im3)+(the(j-2)*im2)+(the(j-1)*im1)
     &       +(the(j)*im)
            lam = (the(j-3)*mm3)+(the(j-2)*mm2)+(the(j-1)*mm1)
     &       +(the(j)*mm)
            endif
 58      continue
   
         if(x.ge.zi(n))then
            som = 0.d0
            do 59 i=1,n
               som = som+the(i-3)
 59         continue
            gl = som
         endif


         call conf(x,j,n,y,pm,zi)

         binf = dexp(-gl + 1.96d0*pm)
         su  = dexp(-gl)
         bsup = dexp(-gl - 1.96d0*pm)

         call conf1(x,j,n,y,pm,zi)
         lbinf = lam - 1.96d0*pm
         lbsup = lam + 1.96d0*pm

         return

         end
c=====================  CONF1  =============================
      subroutine  conf1(x,ni,n,y,pm,zi)
         double precision y(25,25),mmsp,x,pm
         double precision aux(52),vecti(52),res
         integer ni,i,n,j
         double precision zi(-2:20)
           
            do 10 i=1,n
               vecti(i) = mmsp(x,ni,i,zi)
 10         continue   

            do 20 i=1,n
               aux(i) = 0.d0
               do 15 j=1,n
                  aux(i) = aux(i) - y(i,j)*vecti(j)
 15            continue
 20         continue   

            res = 0.d0
            do 30 i=1,n
               res = res + aux(i)*vecti(i)
 30         continue

            pm = dsqrt(res)
               
         end
c=====================  CONF  =============================
      subroutine  conf(x,ni,n,y,pm,zi)
         double precision y(25,25),isp,x,pm
         double precision aux(52),vecti(52),res
         integer ni,i,n,j
         double precision zi(-2:20)

            do 10 i=1,n
               vecti(i) = isp(x,ni,i,zi)
 10         continue   

            do 20 i=1,n
               aux(i) = 0.d0
               do 15 j=1,n
                  aux(i) = aux(i) - y(i,j)*vecti(j)
 15            continue
 20         continue   

            res = 0.d0
            do 30 i=1,n
               res = res + aux(i)*vecti(i)
 30         continue

            pm = dsqrt(res)
               
         end
c==========================   ISP   ==================================
          double precision function isp(x,ni,ns,zi)
             integer ni,ns
             double precision val,mmsp,x
             double precision zi(-2:20)

          if(x.eq.zi(ni))then
             if(ni.le.ns-3)then
                val = 0.d0
             else
                if(ni.le.ns-2)then
           val = ((zi(ni)-zi(ni-1))*mmsp(x,ni,ns,zi))*0.25d0
                else
                   if (ni.eq.ns-1)then
                  val = ((zi(ni)-zi(ni-2))*mmsp(x,ni,ns,zi)+
     &        (zi(ni+3)-zi(ni-1))*mmsp(x,ni,ns+1,zi))*0.25d0
                   else
                      if(ni.eq.ns)then
                  val = ((zi(ni)-zi(ni-3))*mmsp(x,ni,ns,zi)+
     &                (zi(ni+2)-zi(ni-2))*mmsp(x,ni,ns+1,zi)
     &       +(zi(ni+3)-zi(ni-1))*mmsp(x,ni,ns+2,zi))*0.25d0
                      else
                         val = 1.d0
                      endif
                   endif
                endif   
             endif
          else   
          if(ni.lt.ns-3)then
             val = 0.d0
          else
             if(ni.eq.ns-3)then
                 val = (x-zi(ni))*mmsp(x,ni,ns,zi)*0.25d0
             else  
             if(ni.eq.ns-2)then
                   val = ((x-zi(ni-1))*mmsp(x,ni,ns,zi)+
     &       (zi(ni+4)-zi(ni))*mmsp(x,ni,ns+1,zi))*0.25d0
             else   
                if (ni.eq.ns-1)then
                   val =((x-zi(ni-2))*mmsp(x,ni,ns,zi)+
     &             (zi(ni+3)-zi(ni-1))*mmsp(x,ni,ns+1,zi)
     &       +(zi(ni+4)-zi(ni))*mmsp(x,ni,ns+2,zi))*0.25d0
                else
                   if(ni.eq.ns)then
                      val =((x-zi(ni-3))*mmsp(x,ni,ns,zi)+
     &             (zi(ni+2)-zi(ni-2))*mmsp(x,ni,ns+1,zi)
     &             +(zi(ni+3)-zi(ni-1))*mmsp(x,ni,ns+2,zi)
     &        +(zi(ni+4)-zi(ni))*mmsp(x,ni,ns+3,zi))*0.25d0
                   else
                      val = 1.d0
                   endif
                endif
             endif
             endif
          endif 
          endif
             isp = val
             return
             end
c==========================  MMSP   ==================================
          double precision function mmsp(x,ni,ns,zi)
             integer ni,ns
             double precision val,x
             double precision zi(-2:20)

          if(ni.lt.ns-3)then
             val = 0.d0
          else
             if(ns-3.eq.ni)then
                if(x.eq.zi(ni))then
                   val = 0.d0
                else  
                   val = (4.d0*(x-zi(ni))*(x-zi(ni))
     &             *(x-zi(ni)))/((zi(ni+4)-zi(ni))*(zi(ni+3)
     &             -zi(ni))*(zi(ni+2)-zi(ni))*(zi(ni+1)-zi(ni)))
                endif
             else 
                if(ns-2.eq.ni)then
                   if(x.eq.zi(ni))then
                      val = (4.d0*(zi(ni)-zi(ni-1))*(zi(ni)-zi(ni-1)))
     &              /((zi(ni+3)-zi(ni-1))*(zi(ni+2)-zi(ni-1))
     &              *(zi(ni+1)-zi(ni-1)))
                   else  
                      val = (4.d0*(x-zi(ni-1))*(x-zi(ni-1))
     &              *(zi(ni+1)-x))/((zi(ni+3)-zi(ni-1))*(zi(ni+2)
     &              -zi(ni-1))*(zi(ni+1)-zi(ni-1))*(zi(ni+1)-zi(ni)))
     &              +   (4.d0*(x-zi(ni-1))*(x-zi(ni))
     &              *(zi(ni+2)-x))/((zi(ni+3)-zi(ni-1))*(zi(ni+2)
     &              -zi(ni))*(zi(ni+1)-zi(ni))*(zi(ni+2)-zi(ni-1))) 
     &              +   (4.d0*(x-zi(ni))*(x-zi(ni))
     &              *(zi(ni+3)-x))/((zi(ni+3)-zi(ni-1))*(zi(ni+3)
     &              -zi(ni))*(zi(ni+2)-zi(ni))*(zi(ni+1)-zi(ni)))
                   endif
                else  
                   if (ns-1.eq.ni)then
                      if(x.eq.zi(ni))then
                         val = (4.d0*((zi(ni)-zi(ni-2))*(zi(ni+1)
     &                  -zi(ni)))/((zi(ni+2)-zi(ni-2))*(zi(ni+1)
     &                  -zi(ni-1))*(zi(ni+1)-zi(ni-2))))
     &                 +((4.d0*((zi(ni)-zi(ni-1))*(zi(ni+2)-zi(ni))) 
     &                 /((zi(ni+2)-zi(ni-2))*(zi(ni+2)-zi(ni-1))
     &                 *(zi(ni+1)-zi(ni-1)))))
                      else
                        val = (4.d0*((x-zi(ni-2))*(zi(ni+1)
     &                  -x)*(zi(ni+1)-x))/((zi(ni+2)
     &                  -zi(ni-2))*(zi(ni+1)-zi(ni-1))*(zi(ni+1)-
     &                   zi(ni))*(zi(ni+1)-zi(ni-2))))
     &                 +((4.d0*((x-zi(ni-1))*(zi(ni+2)-x) 
     &                 *(zi(ni+1)-x))/((zi(ni+2)-zi(ni-2))
     &                 *(zi(ni+2)-zi(ni-1))*(zi(ni+1)-zi(ni-1))*
     &                 (zi(ni+1)-zi(ni)))))
     &                 +((4.d0*((zi(ni+2)-x)*(zi(ni+2)-x) 
     &                 *(x-zi(ni)))/((zi(ni+2)-zi(ni-2))
     &                 *(zi(ni+2)-zi(ni))*(zi(ni+2)-zi(ni-1))*
     &                 (zi(ni+1)-zi(ni)))))
                      endif 
                   else
                      if(ni.eq.ns)then
                         if(x.eq.zi(ni))then
                            val =(4.d0*(x-zi(ni+1))*(x
     &                    -zi(ni+1))/((zi(ni+1)-zi(ni-1))*(zi(ni+1)
     &                    -zi(ni-2))*(zi(ni+1)-zi(ni-3))))
                         else   
                           val =(4.d0*(x-zi(ni+1))*(x
     &                      -zi(ni+1))*(zi(ni+1)-x)/((zi(ni+1)
     &                      -zi(ni-1))*(zi(ni+1)-zi(ni-2))*(zi(ni+1)
     &                      -zi(ni))*(zi(ni+1)-zi(ni-3))))
                         endif
                      else
                         val = 0.d0
                      endif
                   endif
                endif
             endif
          endif

             mmsp = val
             return
             end
c==========================  SUSP  ====================================
      subroutine susp(x,the,n,su,lam,zi)
         double precision x,ht,ht2,h2,som,lam,su
         double precision htm,h2t,h3,h2n,hn,im,im1,im2,mm1,mm3
         double precision ht3,hht,h4,h3m,hh3,hh2,mm,im3,mm2
         double precision h,gl,hh,the(-2:20)
         integer j,k,n,i
         double precision zi(-2:20)



         som = 0.d0
         do 58 k = 2,n+1
            if ((x.ge.zi(k-1)).and.(x.lt.zi(k)))then
               j = k-1
               if (j.gt.1)then
                  do 55 i=2,j
                     som = som+the(i-4)
 55               continue  
                endif   
            ht = x-zi(j)
            htm= x-zi(j-1)
            h2t= x-zi(j+2)
            ht2 = zi(j+1)-x
            ht3 = zi(j+3)-x
            hht = x-zi(j-2)
            h = zi(j+1)-zi(j)
            hh= zi(j+1)-zi(j-1)
            h2= zi(j+2)-zi(j)
            h3= zi(j+3)-zi(j)
            h4= zi(j+4)-zi(j)
            h3m= zi(j+3)-zi(j-1)
            h2n=zi(j+2)-zi(j-1)
            hn= zi(j+1)-zi(j-2)
            hh3 = zi(j+1)-zi(j-3)
            hh2 = zi(j+2)-zi(j-2)
            mm3 = ((4.d0*ht2*ht2*ht2)/(h*hh*hn*hh3))
            mm2 = ((4.d0*hht*ht2*ht2)/(hh2*hh*h*hn))+((-4.d0*h2t*htm
     &       *ht2)/(hh2*h2n*hh*h))+((4.d0*h2t*h2t*ht)/(hh2*h2*h*h2n))
            mm1 = (4.d0*(htm*htm*ht2)/(h3m*h2n*hh*h))+((-4.d0*htm*ht*
     &       h2t)/(h3m*h2*h*h2n))+((4.d0*ht3*ht*ht)/(h3m*h3*h2*h))
            mm  = 4.d0*(ht*ht*ht)/(h4*h3*h2*h)
            im3 = (0.25d0*(x-zi(j-3))*mm3)+(0.25d0*hh2*mm2)
     &       +(0.25d0*h3m*mm1)+(0.25d0*h4*mm)
            im2 = (0.25d0*hht*mm2)+(h3m*mm1*0.25d0)+(h4*mm*0.25d0)
            im1 = (htm*mm1*0.25d0)+(h4*mm*0.25d0)
            im  = ht*mm*0.25d0
            gl = som +(the(j-3)*im3)+(the(j-2)*im2)+(the(j-1)*im1)
     &       +(the(j)*im)
            lam = (the(j-3)*mm3)+(the(j-2)*mm2)+(the(j-1)*mm1)
     &       +(the(j)*mm)
            endif
 58      continue
   
         if(x.eq.zi(n))then
            som = 0.d0
            do 59 i=1,n
               som = som+the(i-3)
 59         continue
            gl = som
            lam = 4*the(n-3)/(zi(n-2)-zi(n-3))
         endif


         su  = dexp(-gl)

         return

         end


c========================          ESTIMV         ===================
                                
      double precision function estimv(b2,np3,fp,thi,sp,thj,b
     & ,omeg1,omeg2,omeg3)
         double precision v(5000),hes(71,71),omeg(71,71)
         double precision b12(70),hes2(71,71),rl,v12(5000)
         double precision funcpa0,res1,opt2(50)
         double precision h(71,71),hessh(71,71),y(71,71),bh2(4)
         double precision res,k0(3),b(70),pe,tra,d,b2(4),thi,thj
         double precision omeg1(25,25),omeg2(25,25),omeg3(25,25)
         integer n,i,k,j,ndate,nz1,nz2,nz3,np,indx(71)
         integer ier,istop,ni,l,fp,sp,np3
         common /dace3/ndate,nz1,nz2,nz3
         common /opti2/opt2

         do 2 i=1,np3
            bh2(i)=b2(i)
 2       continue

         if (fp.ne.0) bh2(fp)=bh2(fp)+thi
         if (sp.ne.0) bh2(sp)=bh2(sp)+thj    

         n  = nz1+2+nz2+2+nz3+2+5


         k0(1) = dexp(b2(1))

         k0(2) = dexp(b2(2))

         k0(3) = dexp(b2(3))
         
         call marq98(k0,b,n,ni,v,hes,res,ier,istop)

cc         write(*,*)'res ',res

         res1 =funcpa0(b,n,k0)


cc         write(*,*)'res1 ',res1

c----------------------------------
         do 3000 i=1,n-5
            b12(i) = b(i)*b(i)
            opt2(i) = 5.d-5
 3000    continue
         do 3001 i=n-4,n
            b12(i) = b(i)
 3001    continue
           call deriva12(b12,n,v12,rl,k0)


cc         write(*,*)'********** '

          do 3005 i=1,n
             do 3004 j=i,n
                k = (((j-1)*j)/2) +i
                hes2(i,j)= v12(k)
 3004        continue
 3005        continue

        do  3007 i = 2,n
            do 3006 j = 1,i-1
               hes2(i,j)=hes2(j,i)
 3006       continue
 3007    continue


         do 10 i = 1,n
            do 9 j = 1,n
               h(i,j) = -hes2(i,j)
               omeg(i,j) = 0.d0
 9         continue
 10     continue


         do 16 i=1,nz1+2
            do 15 j=1,nz1+2
               omeg(i,j)=k0(1)*omeg1(i,j)
 15        continue
 16     continue   

         k = 0
         do 18 i=nz1+3,nz1+2+nz2+2
            k = k + 1 
            l = 0
            do 17 j=nz1+3,nz1+2+nz2+2
               l = l + 1
               omeg(i,j)=k0(2)*omeg2(k,l)
 17        continue
 18     continue   

         k = 0
         do 20 i=nz1+2+nz2+3,nz1+2+nz2+2+nz3+2
            k = k + 1
            l = 0
            do 19 j=nz1+2+nz2+3,nz1+2+nz2+2+nz3+2
               l = l + 1
               omeg(i,j)=k0(3)*omeg3(k,l)
 19        continue
 20     continue   

         do 100 i = 1,n
            do 90 j = 1,n
               hessh(i,j)= (h(i,j)-(2.d0*omeg(i,j)))
 90         continue   
 100     continue


         np = n
         do 112 i=1,n
            do 111 j=1,n
               y(i,j)=0.d0
 111        continue
            y(i,i)=1.d0
 112     continue
         call ludcmp(hessh,n,np,indx,d)

         do 113 j=1,n
            call lubksb(hessh,n,np,indx,y(1,j))
 113     continue




         tra = 0.d0
         do 150 i=1,n
            do 140 j=1,n
               tra = tra + y(i,j)*h(j,i)
 140        continue
 150     continue
   
         estimv = res1 - tra
c           estimv = res+pe - tra

            write(*,*)'...................'
            write(*,*)k0
            write(*,*)estimv,ni
            write(*,*)tra,res,pe
c            write(*,*)k0,'ddl',tra,ni,res,pe
c            write(*,*)estimv

         return
         end
c=======================  CALOMEG  ===========================
      subroutine calcomeg(n,omeg,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
c        remplissage de la matrice omega n*n
c          elle a 7 diagonales
      double precision omeg(25,25),calc00,calc01,calc02
      integer n,i,j
      double precision m3m3(50),m2m2(50),m1m1(50),mmm(50),m3m2(50)
      double precision m3m1(50),m3m(50),m2m1(50),m2m(50),m1m(50)

      do 5 i=1,n
         do 3 j=1,n
            omeg(i,j)=0.d0
 3       continue
 5    continue
   
      omeg(1,1)=calc00(1,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(1,2)=calc01(1,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(1,3)=calc02(1,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(1,4)=m3m(1)
      omeg(2,1)=omeg(1,2)
      omeg(2,2)=calc00(2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(2,3)=calc01(2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(2,4)=calc02(2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(2,5)=m3m(2)
      omeg(3,1)=omeg(1,3)
      omeg(3,2)=omeg(2,3)
      omeg(3,3)=calc00(3,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(3,4)=calc01(3,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(3,5)=calc02(3,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(3,6)=m3m(3)
      do 10 i=4,n-3
         omeg(i,i-3)=omeg(i-3,i)
         omeg(i,i-2)=omeg(i-2,i)
         omeg(i,i-1)=omeg(i-1,i)
         omeg(i,i)=calc00(i,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
         omeg(i,i+1)=calc01(i,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
         omeg(i,i+2)=calc02(i,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
         omeg(i,i+3)=m3m(i)
 10   continue 
      omeg(n-2,n-5)=omeg(n-5,n-2)
      omeg(n-2,n-4)=omeg(n-4,n-2)
      omeg(n-2,n-3)=omeg(n-3,n-2)
      omeg(n-2,n-2)=calc00(n-2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(n-2,n-1)=calc01(n-2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(n-2,n)=calc02(n-2,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(n-1,n-4)=omeg(n-4,n-1)
      omeg(n-1,n-3)=omeg(n-3,n-1)
      omeg(n-1,n-2)=omeg(n-2,n-1)
      omeg(n-1,n-1)=calc00(n-1,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(n-1,n)=calc01(n-1,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)
      omeg(n,n-3)=omeg(n-3,n)
      omeg(n,n-2)=omeg(n-2,n)
      omeg(n,n-1)=omeg(n-1,n)
      omeg(n,n)=calc00(n,n,m3m3,m2m2,m1m1,mmm,m3m2,
     &                     m3m1,m3m,m2m1,m2m,m1m)

      end
c=========================  CALC00  =========================
          double precision function calc00(j,n,m3m3,m2m2,m1m1,mmm
     &                    ,m3m2,m3m1,m3m,m2m1,m2m,m1m)
             double precision part
             integer j,n
         double precision m3m3(50),m2m2(50),m1m1(50),mmm(50),m3m2(50)
         double precision m3m1(50),m3m(50),m2m1(50),m2m(50),m1m(50)

c        entre i et i+1 ---> m*m et       i = j-3

c       entre i+1 et i+2 ---> m1*m1 et      i = j-2

c       entre i+2 et i+3 ---> m2*m2 et    i = j-1

c       entre i+3 et i+4 ---> m3*m3  et    i = j

             if(j.eq.1)then
                part = m3m3(j)
             else
                if(j.eq.2)then
                   part = m3m3(j) + m2m2(j-1)
                else
                   if(j.eq.3)then
                      part = m3m3(j) + m2m2(j-1) + m1m1(j-2)
                   else
                      if(j.eq.n-2)then
                         part = m2m2(j-1) + m1m1(j-2) + mmm(j-3)
                      else   
                         if(j.eq.n-1)then
                            part = mmm(j-3) + m1m1(j-2)
                         else
                            if(j.eq.n)then
                               part = mmm(j-3)
                            else   
                            part=mmm(j-3)+m1m1(j-2)+m2m2(j-1)+m3m3(j)
                            endif
                         endif
                      endif   
                  endif   
                endif   
             endif 

             calc00 = part
             return
             end
c=========================  CALC01  =========================
           double precision function calc01(j,n,m3m3,m2m2,m1m1,mmm
     &                    ,m3m2,m3m1,m3m,m2m1,m2m,m1m)
             double precision part
             integer j,n
         double precision m3m3(50),m2m2(50),m1m1(50),mmm(50),m3m2(50)
         double precision m3m1(50),m3m(50),m2m1(50),m2m(50),m1m(50)

c        entre j+1 et j+2 ---> m1*m et       i = j-2

c        entre j+2 et j+3 ---> m2*m1 et    i = j -1

c        entre j+3 et j+4 ---> m3*m2 et     i = j 


             if(j.eq.1)then
                part = m3m2(j)
             else   
                if(j.eq.2)then
                   part = m3m2(j) + m2m1(j-1) 
                else
                   if(j.eq.n-2)then
                      part = m1m(j-2) + m2m1(j-1) 
                   else
                      if(j.ne.n-1)then
                         part = m3m2(j) + m2m1(j-1) + m1m(j-2)
                      else
                         part = m1m(j-2)
                      endif
                   endif   
                endif
             endif   

             calc01 = part
             return
             end
c=========================  CALC02  =========================
          double precision function calc02(j,n,m3m3,m2m2,m1m1,mmm
     &                    ,m3m2,m3m1,m3m,m2m1,m2m,m1m)
             double precision part
             integer j,n
         double precision m3m3(50),m2m2(50),m1m1(50),mmm(50),m3m2(50)
         double precision m3m1(50),m3m(50),m2m1(50),m2m(50),m1m(50)

c        entre j+3 et j+4 ---> m2*m et     i = j-1
 
c        entre j+2 et j+3 ---> m3*m1 et       i = j


             if(j.eq.1)then
                part = m3m1(j)
             else   
                if(j.ne.n-2)then
                   part = m3m1(j) + m2m(j-1) 
                else
                   part = m2m(j-1)
                endif
             endif   

             calc02 = part
             return
             end


c=================================    DERIVA    =======================

      subroutine deriva12(b,m,v,rl,k0)

      double precision funcpa3,thn,th,z,rl,b(70),v(5000),vl
      double precision fcith(70),th2,k0(3)
      integer i0,iun,m,m1,ll,i,k,j

c
c     v:matrice d'information+score
c     calcul de la derivee premiere
c
c     - la hessienne et derivee premiere

      th=1.d-4
      thn=-th
      th2=th*th
      z=0.d0
      i0=0
      iun =1
      rl=funcpa3(b,m, iun,z,iun,z,k0)
      do 2 i=1,m
	    fcith(i)=funcpa3(b,m ,i,th,i0,z,k0)
2     continue
      k=0
      m1=m*(m+1)/2
      ll=m1
      do 1 i=1,m
      ll=ll+1
      vl=(fcith(i)-funcpa3( b,m, i,thn,i0,z,k0))/(2.d0*th)
      v(ll)=vl
      do 1 j=1,i
      k=k+1
      v(k)=-(funcpa3( b,m, i,th,j,th,k0)-fcith(j)-fcith(i)+rl)/th2
1     continue
      return
      end

c========================          FUNCPA3         ====================
      double precision function funcpa3(b,np,id,thi,jd,thj,k0)
         double precision  b(70),thi,thj,bh(70)
         double precision the1(-2:20),the2(-2:20),the3(-2:20)
         integer np,id,jd,i,j,k,vj
         double precision res,res1,k0(3),v1,v2,v3,v13,v23
         double precision resa,resb,resc,resd,p00,p11,p22,p33,rese
         double precision som1,som2,som3,dut1(12000),dut2(12000)
         double precision ut1(0:12000),ut2(12000),ut3(12000),dut3(12000)
         double precision h1
         integer no,ndate
         integer nz1,nz2,nz3
         double precision mm3a(12000),mm2a(12000),mm1a(12000),mma(12000)
         double precision im3a(12000),im2a(12000),im1a(12000),ima(12000)
         common /mem1/mm3a,mm2a,mm1a,mma
         common /mem2/im3a,im2a,im1a,ima
         double precision mm3b(12000),mm2b(12000),mm1b(12000),mmb(12000)
         double precision im3b(12000),im2b(12000),im1b(12000),imb(12000)
         common /mem3/mm3b,mm2b,mm1b,mmb
         common /mem4/im3b,im2b,im1b,imb
         double precision mm3c(12000),mm2c(12000),mm1c(12000),mmc(12000)
         double precision im3c(12000),im2c(12000),im1c(12000),imc(12000)
         common /mem5/mm3c,mm2c,mm1c,mmc
         common /mem6/im3c,im2c,im1c,imc
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision date(11000)
         integer da(5000),dv(5000),di(5000)
         common /dace0/date
         common /dace1/zi1,zi2,zi3
         common /dace2/no,da,dv,di
         common /dace3/ndate,nz1,nz2,nz3
         integer nv0(5000),nvl(5000),nvj(5000),ntv(5000),nti(5000)
         common /dace4/nv0,nvl,nvj,ntv,nti


         do 2 i=1,np
            bh(i)=b(i)
 2       continue

         if (id.ne.0) bh(id)=bh(id)+thi
         if (jd.ne.0) bh(jd)=bh(jd)+thj    

         do 3 i=1,nz1+2
            the1(i-3)=bh(i)
 3       continue
         do 4 i=1,nz2+2
            j = nz1+2+i
            the2(i-3)=bh(j)
 4       continue
         do 5 i=1,nz3+2
            j = nz2+2+nz1+2+i
            the3(i-3)=bh(j)
 5       continue

         v1 = dexp(bh(nz1+2+nz2+2+nz3+2+1))
         v2 = dexp(bh(nz1+2+nz2+2+nz3+2+2))
         v3 = dexp(bh(nz1+2+nz2+2+nz3+2+3))
         v13= dexp(bh(nz1+2+nz2+2+nz3+2+4))
         v23= dexp(bh(nz1+2+nz2+2+nz3+2+5))

c----------  calcul de u(ti) ---------------------------
c    attention the(1)  sont en nz=1
c        donc en ti on a the(i)

         vj = 0
         som1 = 0.d0
         ut1(0) = 0.d0
         dut1(1) = (the1(-2)*4.d0/(zi1(2)-zi1(1)))
         ut1(1) = the1(-2)*dut1(1)*0.25d0*(zi1(1)-zi1(-2))
         do 7 i=2,ndate-1
            do 6 k = 2,nz1
               if ((date(i).ge.zi1(k-1)).and.(date(i).lt.zi1(k)))then
                  j = k-1
                  if ((j.gt.1).and.(j.gt.vj))then
                     som1 = som1+the1(j-4)
                     vj  = j
                  endif   
               endif
 6          continue 
            ut1(i) = som1 +(the1(j-3)*im3a(i))+(the1(j-2)*im2a(i))
     &       +(the1(j-1)*im1a(i))+(the1(j)*ima(i))
            dut1(i) = (the1(j-3)*mm3a(i))+(the1(j-2)*mm2a(i))
     &       +(the1(j-1)*mm1a(i))+(the1(j)*mma(i))
 7       continue
         i = nz1
         h1 = (zi1(i)-zi1(i-1))
         ut1(ndate) = som1+the1(i-4)+the1(i-3)+the1(i-2)+the1(i-1)
         dut1(ndate) = (4.d0*the1(i-1)/h1)

         vj = 0
         som2 = 0.d0
         dut2(1) = (the2(-2)*4.d0/(zi2(2)-zi2(1)))
         ut2(1) = the2(-2)*dut2(1)*0.25d0*(zi2(1)-zi2(-2))
         do 9 i=2,ndate-1
            do 8 k = 2,nz2
               if ((date(i).ge.zi2(k-1)).and.(date(i).lt.zi2(k)))then
                  j = k-1
                  if ((j.gt.1).and.(j.gt.vj))then
                     som2 = som2+the2(j-4)
                     vj  = j
                  endif   
               endif
 8          continue 
            ut2(i) = som2 +(the2(j-3)*im3b(i))+(the2(j-2)*im2b(i))
     &       +(the2(j-1)*im1b(i))+(the2(j)*imb(i))
            dut2(i) = (the2(j-3)*mm3b(i))+(the2(j-2)*mm2b(i))
     &       +(the2(j-1)*mm1b(i))+(the2(j)*mmb(i))
 9       continue
         i = nz2
         h1 = (zi2(i)-zi2(i-1))
         ut2(ndate) = som2+the2(i-4)+the2(i-3)+the2(i-2)+the2(i-1)
         dut2(ndate) = (4.d0*the2(i-1)/h1)

         vj = 0
         som3 = 0.d0
         dut3(1) = (the3(-2)*4.d0/(zi3(2)-zi3(1)))
         ut3(1) = the3(-2)*dut3(1)*0.25d0*(zi3(1)-zi3(-2))
         do 11 i=2,ndate-1
            do 10 k = 2,nz3
               if ((date(i).ge.zi3(k-1)).and.(date(i).lt.zi3(k)))then
                  j = k-1
                  if ((j.gt.1).and.(j.gt.vj))then
                     som3 = som3+the3(j-4)
                     vj  = j
                  endif   
               endif
 10         continue 
            ut3(i) = som3 +(the3(j-3)*im3c(i))+(the3(j-2)*im2c(i))
     &       +(the3(j-1)*im1c(i))+(the3(j)*imc(i))
            dut3(i) = (the3(j-3)*mm3c(i))+(the3(j-2)*mm2c(i))
     &       +(the3(j-1)*mm1c(i))+(the3(j)*mmc(i))
 11      continue
         i = nz3
         h1 = (zi3(i)-zi3(i-1))
         ut3(ndate) = som3+the3(i-4)+the3(i-3)+the3(i-2)+the3(i-1)
         dut3(ndate) = (4.d0*the3(i-1)/h1)

c---------- calcul de la vraisemblance ------------------

          res = 0.d0
          do 15 i=1,no

             res1 = 0.d0
             resa = 0.d0
             resb = 0.d0
             resc = 0.d0
             resd = 0.d0
             rese = 0.d0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

             if(da(i).eq.0)then
c              pas diagnostique dement
                if(di(i).eq.0)then
c                 pas institutionalise
                   resa = p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                   resb = p00(date(nvl(i)),date(ntv(i)),the1,the2,the3)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))
                   endif
                   call p01(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            resc,v1,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v1
                   endif
                   call p02(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            resd,v2,v23)
                   if(dv(i).eq.1)then
                      resd=resd*dut3(ntv(i))*v2
                   endif
                   call p03(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            rese,v1,v2,v3,v13,v23)
                   if(dv(i).eq.1)then
                      rese=rese*dut3(ntv(i))*v3
                   endif
                   res1 = dlog(resa*(resb+resc+resd+rese))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,the3)
                      resa = resa*dut2(nti(i))*p22(date(nti(i)),
     &               date(nvl(i)),the1,the3,v2,v23)
                      resb =p22(date(nvl(i)),date(ntv(i))
     &                     ,the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2
                      endif
                      resc = 0.d0
                      if(nvl(i).lt.ntv(i))then
                         call p23(date(nvl(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                         if(dv(i).eq.1)then
                          resc=resc*dut3(ntv(i))*v3
                         endif
                      endif   
                      res1 = dlog(resa*(resb+resc))
                   else
c                         institutionalise apres vl
                      resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                      resb=p00(date(nvl(i)),date(nti(i)),the1,the2,the3)
                      resb = resb*dut2(nti(i))*p22(date(nti(i)),
     &               date(ntv(i)),the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2
                      endif
                      call p23(date(nti(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2
     &                ,the3)*dut2(nti(i))
                      if(dv(i).eq.1)then
                         resc=resc*dut3(ntv(i))*v3
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resd,v1,v13)
                      resd=resd*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resd=resd*dut3(ntv(i))*v3
                      endif
                      res1 = dlog(resa*(resb+resc+resd))
                   endif   
                endif
             else
c              diagnostique dement
                if(di(i).eq.0)then
c                  pas institutionalise
                   call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resa,v1,v13)
                   resa=resa*p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &              the3)*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                   resb=p11(date(nti(i)),date(ntv(i)),the2,the3,
     &                  v1,v13)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))*v1
                   endif
                   call p13(date(nti(i)),date(ntv(i)),the2,the3,resc,
     &                  v1,v3,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v3
                   endif
                   res1=dlog(resa*(resb+resc))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,
     &            the3)*dut2(nti(i))*p22(date(nti(i)),date(nvl(i)),
     &               the1,the3,v2,v23)
                      call p23(date(nvl(i)),date(nvj(i)),the1,the3,
     &                resb,v2,v3,v23)
                      resa=resa*resb*p33(date(nvj(i)),date(ntv(i)),
     &                 the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                      res1=dlog(resa)
                   else
                      if(nti(i).le.nvj(i))then
c                         institutionalise entre vl et vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &        the3)*p33(date(nvj(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resb=resb*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(nvj(i)),the3,v3)
                      call p23(date(nti(i)),date(nvj(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2,
     &                     the3)*dut2(nti(i))
                         res1=dlog(resa*(resb+resc))
                      else
c                         institutionalise apres vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &        the3)
                      call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resa=resa*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                      resa=resa*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                          res1=dlog(resa*resb)
                      endif
                   endif   
                endif
             endif   
             res = res + res1  
 15       continue   

ccc          write(*,*)'funcpa3',res
          funcpa3 = res
          return
          end

c========================          FUNCPA0         ====================
      double precision function funcpa0(b,np,k0)
         double precision  b(70),bh(70)
         double precision the1(-2:20),the2(-2:20),the3(-2:20)
         integer np,i,j,k,vj
         double precision pe,res,res1,k0(3),v1,v2,v3,v13,v23
         double precision resa,resb,resc,resd,p00,p11,p22,p33
         double precision som2,som3,dut2(12000),rese
         double precision ut2(12000),ut3(12000),dut3(12000)
         double precision h1
         double precision ve1(5000,10),ve2(5000,10),ve3(5000,10)
         double precision ve01(4000,6),ve02(4000,6),ve04(4000,6)
         double precision ve14(4000,6),ve24(4000,6)
         double precision ve13(4000,6),ve23(4000,6),ve34(4000,6)
         integer nv01,nv02,nv04,nv14,nv24,nv13,nv23,nv34
         integer no,ndate
         integer nz1,nz2,nz3,nva1,nva2,nva3
         double precision mm3a(12000),mm2a(12000),mm1a(12000),mma(12000)
         double precision im3a(12000),im2a(12000),im1a(12000),ima(12000)
         common /mem1/mm3a,mm2a,mm1a,mma
         common /mem2/im3a,im2a,im1a,ima
         double precision mm3b(12000),mm2b(12000),mm1b(12000),mmb(12000)
         double precision im3b(12000),im2b(12000),im1b(12000),imb(12000)
         common /mem3/mm3b,mm2b,mm1b,mmb
         common /mem4/im3b,im2b,im1b,imb
         double precision mm3c(12000),mm2c(12000),mm1c(12000),mmc(12000)
         double precision im3c(12000),im2c(12000),im1c(12000),imc(12000)
         common /mem5/mm3c,mm2c,mm1c,mmc
         common /mem6/im3c,im2c,im1c,imc
         double precision zi1(-2:20),zi2(-2:20),zi3(-2:20)
         double precision date(11000)
         integer da(5000),dv(5000),di(5000)
         common /dace0/date
         common /dace1/zi1,zi2,zi3
         common /dace2/no,da,dv,di
         common /dace3/ndate,nz1,nz2,nz3
         integer nv0(5000),nvl(5000),nvj(5000),ntv(5000),nti(5000)
         common /dace4/nv0,nvl,nvj,ntv,nti
         common /ve1/ve01,ve02,ve04,ve14,ve24,ve13,ve23,ve34
         common /ve2/nv01,nv02,nv04,nv14,nv24,nv13,nv23,nv34
         double precision vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34
         common /ve3/vv01,vv02,vv04,vv14,vv24,vv13,vv23,vv34

         do 2 i=1,np
            bh(i)=b(i)
 2       continue

         do 3 i=1,nz1+2
            the1(i-3)=bh(i)*bh(i)
 3       continue
         do 4 i=1,nz2+2
            j = nz1+2+i
            the2(i-3)=bh(j)*bh(j)
 4       continue
         do 5 i=1,nz3+2
            j = nz2+2+nz1+2+i
            the3(i-3)=bh(j)*bh(j)
 5       continue


         v1 = dexp(bh(np-4))
         v2 = dexp(bh(np-3))
         v3 = dexp(bh(np-2))
         v13= dexp(bh(np-1))
         v23= dexp(bh(np))

c----------  calcul de u(ti) ---------------------------
c    attention the(1)  sont en nz=1
c        donc en ti on a the(i)


         vj = 0
         som2 = 0.d0
         dut2(1) = (the2(-2)*4.d0/(zi2(2)-zi2(1)))
         ut2(1) = the2(-2)*dut2(1)*0.25d0*(zi2(1)-zi2(-2))
         do 9 i=2,ndate-1
            do 8 k = 2,nz2
               if ((date(i).ge.zi2(k-1)).and.(date(i).lt.zi2(k)))then
                  j = k-1
                  if ((j.gt.1).and.(j.gt.vj))then
                     som2 = som2+the2(j-4)
                     vj  = j
                  endif   
               endif
 8          continue 
            ut2(i) = som2 +(the2(j-3)*im3b(i))+(the2(j-2)*im2b(i))
     &       +(the2(j-1)*im1b(i))+(the2(j)*imb(i))
            dut2(i) = (the2(j-3)*mm3b(i))+(the2(j-2)*mm2b(i))
     &       +(the2(j-1)*mm1b(i))+(the2(j)*mmb(i))
 9       continue
         i = nz2
         h1 = (zi2(i)-zi2(i-1))
         ut2(ndate) = som2+the2(i-4)+the2(i-3)+the2(i-2)+the2(i-1)
         dut2(ndate) = (4.d0*the2(i-1)/h1)

         vj = 0
         som3 = 0.d0
         dut3(1) = (the3(-2)*4.d0/(zi3(2)-zi3(1)))
         ut3(1) = the3(-2)*dut3(1)*0.25d0*(zi3(1)-zi3(-2))
         do 11 i=2,ndate-1
            do 10 k = 2,nz3
               if ((date(i).ge.zi3(k-1)).and.(date(i).lt.zi3(k)))then
                  j = k-1
                  if ((j.gt.1).and.(j.gt.vj))then
                     som3 = som3+the3(j-4)
                     vj  = j
                  endif   
               endif
 10         continue 
            ut3(i) = som3 +(the3(j-3)*im3c(i))+(the3(j-2)*im2c(i))
     &       +(the3(j-1)*im1c(i))+(the3(j)*imc(i))
            dut3(i) = (the3(j-3)*mm3c(i))+(the3(j-2)*mm2c(i))
     &       +(the3(j-1)*mm1c(i))+(the3(j)*mmc(i))
 11      continue
         i = nz3
         h1 = (zi3(i)-zi3(i-1))
         ut3(ndate) = som3+the3(i-4)+the3(i-3)+the3(i-2)+the3(i-1)
         dut3(ndate) = (4.d0*the3(i-1)/h1)

c---------- calcul de la vraisemblance ------------------
             vv01 = 1.d0
             vv02 = 1.d0
             vv04 = 1.d0
             vv14 = 1.d0
             vv24 = 1.d0
             vv13 = 1.d0
             vv23 = 1.d0
             vv34 = 1.d0
          res = 0.d0
          do 15 i=1,no

             res1 = 0.d0
             resa = 0.d0
             resb = 0.d0
             resc = 0.d0
             resd = 0.d0
             rese = 0.d0

             if(da(i).eq.0)then
c              pas diagnostique dement
                if(di(i).eq.0)then
c                 pas institutionalise
                   resa = p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                   resb = p00(date(nvl(i)),date(ntv(i)),the1,the2,the3)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))
                   endif
                   call p01(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            resc,v1,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v1
                   endif
                   call p02(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            resd,v2,v23)
                   if(dv(i).eq.1)then
                      resd=resd*dut3(ntv(i))*v2
                   endif
                   call p03(date(nvl(i)),date(ntv(i)),the1,the2,the3,
     &            rese,v1,v2,v3,v13,v23)
                   if(dv(i).eq.1)then
                      rese=rese*dut3(ntv(i))*v3
                   endif
                   res1 = dlog(resa*(resb+resc+resd+rese))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,the3)
                      resa = resa*dut2(nti(i))*p22(date(nti(i)),
     &               date(nvl(i)),the1,the3,v2,v23)
                      resb =p22(date(nvl(i)),date(ntv(i))
     &                     ,the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2
                      endif
                      resc = 0.d0
                      if(nvl(i).lt.ntv(i))then
                         call p23(date(nvl(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                         if(dv(i).eq.1)then
                          resc=resc*dut3(ntv(i))*v3
                         endif
                      endif   
                      res1 = dlog(resa*(resb+resc))
                   else
c                         institutionalise apres vl
                      resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,the3)
                      resb=p00(date(nvl(i)),date(nti(i)),the1,the2,the3)
                      resb = resb*dut2(nti(i))*p22(date(nti(i)),
     &               date(ntv(i)),the1,the3,v2,v23)
                      if(dv(i).eq.1)then
                         resb=resb*dut3(ntv(i))*v2
                      endif
                      call p23(date(nti(i)),date(ntv(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2
     &                ,the3)*dut2(nti(i))
                      if(dv(i).eq.1)then
                         resc=resc*dut3(ntv(i))*v3
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resd,v1,v13)
                      resd=resd*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resd=resd*dut3(ntv(i))*v3
                      endif
                      res1 = dlog(resa*(resb+resc+resd))
                   endif   
                endif
             else
c              diagnostique dement
                if(di(i).eq.0)then
c                  pas institutionalise
                   call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resa,v1,v13)
                   resa=resa*p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &              the3)*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                   resb=p11(date(nti(i)),date(ntv(i)),the2,the3,
     &                  v1,v13)
                   if(dv(i).eq.1)then
                      resb=resb*dut3(ntv(i))*v1
                   endif
                   call p13(date(nti(i)),date(ntv(i)),the2,the3,resc,
     &                  v1,v3,v13)
                   if(dv(i).eq.1)then
                      resc=resc*dut3(ntv(i))*v3
                   endif
                   res1=dlog(resa*(resb+resc))
                else
c                   institutionalise
                   if(nti(i).le.nvl(i))then
c                         institutionalise avant vl
                      resa=p00(date(nv0(i)),date(nti(i)),the1,the2,
     &            the3)*dut2(nti(i))*p22(date(nti(i)),date(nvl(i)),
     &               the1,the3,v2,v23)
                      call p23(date(nvl(i)),date(nvj(i)),the1,the3,
     &                resb,v2,v3,v23)
                      resa=resa*resb*p33(date(nvj(i)),date(ntv(i)),
     &                 the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                      res1=dlog(resa)
                   else
                      if(nti(i).le.nvj(i))then
c                         institutionalise entre vl et vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &        the3)*p33(date(nvj(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                      call p01(date(nvl(i)),date(nti(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resb=resb*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(nvj(i)),the3,v3)
                      call p23(date(nti(i)),date(nvj(i)),the1,the3,
     &                resc,v2,v3,v23)
                      resc=resc*p00(date(nvl(i)),date(nti(i)),the1,the2,
     &                     the3)*dut2(nti(i))
                         res1=dlog(resa*(resb+resc))
                      else
c                         institutionalise apres vj
                         resa=p00(date(nv0(i)),date(nvl(i)),the1,the2,
     &        the3)
                      call p01(date(nvl(i)),date(nvj(i)),the1,the2,the3,
     &                resb,v1,v13)
                      resa=resa*p11(date(nvj(i)),date(nti(i)),the2,the3,
     &                  v1,v13)
                      resa=resa*dut2(nti(i))*v13*
     &                p33(date(nti(i)),date(ntv(i)),the3,v3)
                      if(dv(i).eq.1)then
                         resa=resa*dut3(ntv(i))*v3
                      endif
                          res1=dlog(resa*resb)
                      endif
                   endif   
                endif
             endif   
             res = res + res1  
 15       continue   


          funcpa0 = res
          return
          end



